using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices; 
using System.Text;
using System.IO;
using System.Diagnostics;
using System.Threading;
using System.Data.SqlClient;
//using System.Management;
using Microsoft.Win32;

namespace PropellentNet
{
	
	public class ExplorerCTRL : System.Windows.Forms.UserControl
	{
		
		#region Win32 API
		[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = false)]
		public static extern int SendMessage(IntPtr hWnd, uint Msg, int wParam, ref TVSORTCB lParam);
		
		[StructLayout(LayoutKind.Sequential)] 
			public struct TVSORTCB 
		{ 
			public IntPtr hParent ; 
			public exCompareNodes lpfnCompare ; 
			public IntPtr lParam ; 
		} 
		
		[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
			public struct SHELLEXECUTEINFO
		{
			public int cbSize;
			public uint fMask;
			public IntPtr hwnd;
			public String lpVerb;
			public String lpFile;
			public String lpParameters;
			public String lpDirectory;
			public int nShow;
			public int hInstApp;
			public int lpIDList;
			public String lpClass;
			public int hkeyClass;
			public uint dwHotKey;
			public int hIcon;
			public int hProcess;
		}

		[DllImport("shell32.dll", CharSet = CharSet.Auto)]
		static extern bool ShellExecuteEx(ref SHELLEXECUTEINFO lpExecInfo);
		
		
		[DllImport("kernel32.dll")]
		static extern uint GetFullPathName(string lpFileName, 
			uint nBufferLength,
			[Out] StringBuilder lpBuffer, 
			out StringBuilder lpFilePart);
		
		public enum DriveType : uint
		{
			/// <summary>The drive type cannot be determined.</summary>
			Unknown = 0,    //DRIVE_UNKNOWN
			/// <summary>The root path is invalid, for example, no volume is mounted at the path.</summary>
			Error = 1,        //DRIVE_NO_ROOT_DIR
			/// <summary>The drive is a type that has removable media, for example, a floppy drive or removable hard disk.</summary>
			Removable = 2,    //DRIVE_REMOVABLE
			/// <summary>The drive is a type that cannot be removed, for example, a fixed hard drive.</summary>
			Fixed = 3,        //DRIVE_FIXED
			/// <summary>The drive is a remote (network) drive.</summary>
			Remote = 4,        //DRIVE_REMOTE
			/// <summary>The drive is a CD-ROM drive.</summary>
			CDROM = 5,        //DRIVE_CDROM
			/// <summary>The drive is a RAM disk.</summary>
			RAMDisk = 6        //DRIVE_RAMDISK
		}
		
		[DllImport("kernel32.dll")]
		public static extern DriveType GetDriveType([MarshalAs(UnmanagedType.LPStr)] string lpRootPathName);
		
		public const int TV_FIRST = 0x1100 ; 
		public const int TVM_SORTCHILDRENCB = TV_FIRST + 21 ; 
		private TreeNode rootNode; 
		
		#endregion Win32 API
		
		#region App Declares
        private System.Windows.Forms.TreeView trvExplorer;
		private System.Windows.Forms.ListView lsvExplorer;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ImageList imgIcons;
		private System.Windows.Forms.ColumnHeader hrdName;
		private System.Windows.Forms.ColumnHeader hrdSize;
		private System.Windows.Forms.ColumnHeader hrdType;
		private System.Windows.Forms.ColumnHeader hrdDateModified;
		private System.Windows.Forms.ColumnHeader hrdDateCreated;
		private System.IO.FileSystemWatcher fswCurrentDirectory;
		private System.Windows.Forms.ContextMenu ctmFiles;
		private System.Windows.Forms.ImageList imgIconsLarge;
		private System.Windows.Forms.ImageList imgThumbNails;
		#endregion App Declares
		
		#region My Declares
		
		public enum wdViews :int {SmallIcon, LargeIcon, Details, List, Thumbnail}
		private wdViews My_ListView;

		#region My Event Declares
		public event exBeginBuildTree BeginBuildTree;
		public event exEndBuildTree EndBuildTree;
		public event exBeginNewTreeNode BeginNewNode;
		public event exEndNewTreeNode EndNewNode;
		public event exBeginNodeCollapes BeingCollapes;
		public event exEndNodeCollapes EndCollapes;
		public event exBeginNodeExpand BeginExpand;
		public event exEndNodeExpand EndExpand;
		public event exBeginRenameFile BeginRenameFile;
		public event exEndRenameFile EndRenameFile;
		public event exBeginRenameFolder BeginRenameFolder;
		public event exEndRenameFolder EndRenameFolder;
		public event exDeleteFile DeleteFile;
		public event exDirectoryChanged DirectoryChanged;
		public event exStatusBar StatusChanged;
		public event exBeginExecuteFile BeginExecuteFile;
		public event exEndExecuteFile EndExecuteFile;
		public event exShowProgress ShowProgress;
		public event exStopProgress StopProgress;
		#endregion My Event Declares
		private TreeNode My_RightClickNode = null;
		private string My_PasteFolder = "";
		private int My_StillShowProgress = 0;
		private bool My_KeyDownFirst = false;
		private long My_DragDistance = 0;
		private Hashtable My_UncPaths;
		private Hashtable My_MappedDrives;
		private Hashtable My_ImageArray;
		private Hashtable My_FileType;
		private TreeNode My_Computer = null;
		private TreeNode My_Desktop = null;
		private TreeNode My_NetworkPlaces = null;
		private TreeNode My_Favorites = null;
		private bool My_Loaded = false;
		private FindFiles My_FindFiles = null;
		private bool My_FirstRun = true;
		private TreeNode My_DragFolder;
		private Hashtable My_WatchDog;
		private bool My_StopDragging = false;
		private ListViewColumnSorter My_ColumnSorter;
		private CaseInsensitiveComparer My_TreeSorter;
		private TreeNodeUtilities My_TreeNodeUtils;
		private ArrayList My_ThumbnailExts = new ArrayList();
        private Splitter splitter1;
		private bool My_AddingImage = false;
		#endregion My Declares
		
		#region Inilizers
		public ExplorerCTRL()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.trvExplorer = new System.Windows.Forms.TreeView();
            this.imgIcons = new System.Windows.Forms.ImageList(this.components);
            this.lsvExplorer = new System.Windows.Forms.ListView();
            this.hrdName = new System.Windows.Forms.ColumnHeader();
            this.hrdSize = new System.Windows.Forms.ColumnHeader();
            this.hrdType = new System.Windows.Forms.ColumnHeader();
            this.hrdDateModified = new System.Windows.Forms.ColumnHeader();
            this.hrdDateCreated = new System.Windows.Forms.ColumnHeader();
            this.imgIconsLarge = new System.Windows.Forms.ImageList(this.components);
            this.fswCurrentDirectory = new System.IO.FileSystemWatcher();
            this.ctmFiles = new System.Windows.Forms.ContextMenu();
            this.imgThumbNails = new System.Windows.Forms.ImageList(this.components);
            this.splitter1 = new System.Windows.Forms.Splitter();
            ((System.ComponentModel.ISupportInitialize)(this.fswCurrentDirectory)).BeginInit();
            this.SuspendLayout();
            // 
            // trvExplorer
            // 
            this.trvExplorer.AllowDrop = true;
            this.trvExplorer.Dock = System.Windows.Forms.DockStyle.Top;
            this.trvExplorer.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.trvExplorer.HideSelection = false;
            this.trvExplorer.ImageIndex = 0;
            this.trvExplorer.ImageList = this.imgIcons;
            this.trvExplorer.LabelEdit = true;
            this.trvExplorer.Location = new System.Drawing.Point(0, 0);
            this.trvExplorer.Name = "trvExplorer";
            this.trvExplorer.SelectedImageIndex = 0;
            this.trvExplorer.ShowRootLines = false;
            this.trvExplorer.Size = new System.Drawing.Size(299, 178);
            this.trvExplorer.TabIndex = 0;
            this.trvExplorer.Resize += new System.EventHandler(this.trvExplorer_Resize);
            this.trvExplorer.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.trvExplorer_AfterLabelEdit);
            this.trvExplorer.BeforeExpand += new System.Windows.Forms.TreeViewCancelEventHandler(this.trvExplorer_BeforeExpand);
            this.trvExplorer.BeforeCollapse += new System.Windows.Forms.TreeViewCancelEventHandler(this.trvExplorer_BeforeCollapse);
            this.trvExplorer.MouseUp += new System.Windows.Forms.MouseEventHandler(this.trvExplorer_MouseUp);
            this.trvExplorer.DragDrop += new System.Windows.Forms.DragEventHandler(this.trvExplorer_DragDrop);
            this.trvExplorer.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.trvExplorer_AfterSelect);
            this.trvExplorer.MouseMove += new System.Windows.Forms.MouseEventHandler(this.trvExplorer_MouseMove);
            this.trvExplorer.MouseDown += new System.Windows.Forms.MouseEventHandler(this.trvExplorer_MouseDown);
            this.trvExplorer.KeyUp += new System.Windows.Forms.KeyEventHandler(this.trvExplorer_KeyUp);
            this.trvExplorer.BeforeLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.trvExplorer_BeforeLabelEdit);
            this.trvExplorer.DragOver += new System.Windows.Forms.DragEventHandler(this.trvExplorer_DragOver);
            // 
            // imgIcons
            // 
            this.imgIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
            this.imgIcons.ImageSize = new System.Drawing.Size(16, 16);
            this.imgIcons.TransparentColor = System.Drawing.Color.White;
            // 
            // lsvExplorer
            // 
            this.lsvExplorer.AllowDrop = true;
            this.lsvExplorer.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.hrdName,
            this.hrdSize,
            this.hrdType,
            this.hrdDateModified,
            this.hrdDateCreated});
            this.lsvExplorer.Dock = System.Windows.Forms.DockStyle.Fill;
            this.lsvExplorer.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.lsvExplorer.HideSelection = false;
            this.lsvExplorer.LabelEdit = true;
            this.lsvExplorer.LargeImageList = this.imgIconsLarge;
            this.lsvExplorer.Location = new System.Drawing.Point(0, 181);
            this.lsvExplorer.Name = "lsvExplorer";
            this.lsvExplorer.Size = new System.Drawing.Size(299, 329);
            this.lsvExplorer.SmallImageList = this.imgIcons;
            this.lsvExplorer.TabIndex = 2;
            this.lsvExplorer.UseCompatibleStateImageBehavior = false;
            this.lsvExplorer.View = System.Windows.Forms.View.Details;
            this.lsvExplorer.Validated += new System.EventHandler(this.lsvExplorer_Validated);
            this.lsvExplorer.AfterLabelEdit += new System.Windows.Forms.LabelEditEventHandler(this.lsvExplorer_AfterLabelEdit);
            this.lsvExplorer.SelectedIndexChanged += new System.EventHandler(this.lsvExplorer_SelectedIndexChanged);
            this.lsvExplorer.SizeChanged += new System.EventHandler(this.lsvExplorer_SizeChanged);
            this.lsvExplorer.DoubleClick += new System.EventHandler(this.lsvExplorer_DoubleClick);
            this.lsvExplorer.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lsvExplorer_MouseUp);
            this.lsvExplorer.DragDrop += new System.Windows.Forms.DragEventHandler(this.lsvExplorer_DragDrop);
            this.lsvExplorer.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.lsvExplorer_ColumnClick);
            this.lsvExplorer.MouseMove += new System.Windows.Forms.MouseEventHandler(this.lsvExplorer_MouseMove);
            this.lsvExplorer.KeyUp += new System.Windows.Forms.KeyEventHandler(this.lsvExplorer_KeyUp);
            this.lsvExplorer.BeforeLabelEdit += new System.Windows.Forms.LabelEditEventHandler(this.lsvExplorer_BeforeLabelEdit);
            this.lsvExplorer.KeyDown += new System.Windows.Forms.KeyEventHandler(this.lsvExplorer_KeyDown);
            this.lsvExplorer.DragOver += new System.Windows.Forms.DragEventHandler(this.lsvExplorer_DragOver);
            // 
            // hrdName
            // 
            this.hrdName.Text = "Name";
            this.hrdName.Width = 276;
            // 
            // hrdSize
            // 
            this.hrdSize.Text = "Size";
            this.hrdSize.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.hrdSize.Width = 81;
            // 
            // hrdType
            // 
            this.hrdType.Text = "Type";
            this.hrdType.Width = 128;
            // 
            // hrdDateModified
            // 
            this.hrdDateModified.Text = "Date Modified";
            this.hrdDateModified.Width = 116;
            // 
            // hrdDateCreated
            // 
            this.hrdDateCreated.Text = "DateCreated";
            this.hrdDateCreated.Width = 131;
            // 
            // imgIconsLarge
            // 
            this.imgIconsLarge.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
            this.imgIconsLarge.ImageSize = new System.Drawing.Size(32, 32);
            this.imgIconsLarge.TransparentColor = System.Drawing.Color.White;
            // 
            // fswCurrentDirectory
            // 
            this.fswCurrentDirectory.EnableRaisingEvents = true;
            this.fswCurrentDirectory.SynchronizingObject = this;
            this.fswCurrentDirectory.Renamed += new System.IO.RenamedEventHandler(this.fswCurrentDirectory_Renamed);
            this.fswCurrentDirectory.Deleted += new System.IO.FileSystemEventHandler(this.fswCurrentDirectory_Deleted);
            this.fswCurrentDirectory.Created += new System.IO.FileSystemEventHandler(this.fswCurrentDirectory_Created);
            this.fswCurrentDirectory.Changed += new System.IO.FileSystemEventHandler(this.fswCurrentDirectory_Changed);
            // 
            // imgThumbNails
            // 
            this.imgThumbNails.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
            this.imgThumbNails.ImageSize = new System.Drawing.Size(64, 64);
            this.imgThumbNails.TransparentColor = System.Drawing.Color.White;
            // 
            // splitter1
            // 
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 178);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(299, 3);
            this.splitter1.TabIndex = 3;
            this.splitter1.TabStop = false;
            // 
            // ExplorerCTRL
            // 
            this.Controls.Add(this.lsvExplorer);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.trvExplorer);
            this.Name = "ExplorerCTRL";
            this.Size = new System.Drawing.Size(299, 510);
            this.Load += new System.EventHandler(this.ExplorerCTRL_Load);
            ((System.ComponentModel.ISupportInitialize)(this.fswCurrentDirectory)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion
		#endregion Inilizers
		
		#region Events
		private void ExplorerCTRL_Load(object sender, System.EventArgs e)
		{
			
			try
			{
				My_FirstRun = bool.Parse(Registry.CurrentUser.CreateSubKey("Software\\WD\\Explorer").GetValue("FirstRun").ToString());
			}
			catch{}
			 
			My_TreeNodeUtils = new TreeNodeUtilities();

			Registry.CurrentUser.CreateSubKey("Software\\WD\\Explorer").SetValue("FirstRun", "False");
			My_WatchDog = new Hashtable();
			My_ColumnSorter = new ListViewColumnSorter();
			
			this.lsvExplorer.ListViewItemSorter = My_ColumnSorter;
			
			My_TreeSorter = new CaseInsensitiveComparer();
			
			My_ThumbnailExts.Add(".dwg");
			My_ThumbnailExts.Add(".jpg");
			My_ThumbnailExts.Add(".bmp");
			My_ThumbnailExts.Add(".tif");
			My_ThumbnailExts.Add(".tiff");

            buildControl();
			
		}
		private void mnuEvents(object sender, EventArgs e)
		{
			if ((My_RightClickNode != null && ((MenuItem)sender).Text == "Add To \"" + My_RightClickNode.Text + ".zip\"") || (this.lsvExplorer.SelectedItems.Count > 0 && ((MenuItem)sender).Text == "Add To \"" + Path.GetFileNameWithoutExtension(this.lsvExplorer.SelectedItems[0].Text) + ".zip\""))
				filZip(true);
			else
			{
				switch(((MenuItem)sender).Text)
				{
					case "Add To Zip...":
						filZip(false);
						break;
					case "Add To Favorites":
					
						string linkPath = "";
					
						if (this.ActiveControl == this.lsvExplorer)
							linkPath = currentDirectoy() + My_PasteFolder;
						else
							linkPath = directoyFromNode(My_RightClickNode);
					
						if (System.IO.Directory.Exists(linkPath))
						{
						
							if(linkPath.EndsWith("\\"))
								linkPath = linkPath.Substring(0,linkPath.Length-1);
						
							string linkName = linkPath.Split(new char[] {'\\'})[linkPath.Split(new char[] {'\\'}).Length-1];
							TreeNode[] tmpTreeChild = new TreeNode[] {new TreeNode("Searching...", 1, 1)};
							TreeNode tmpNode = new TreeNode(linkName, this.containsImage("Folder"), this.containsImage("Folder"), tmpTreeChild);
							tmpNode.Tag = linkPath;
							this.AddNode(tmpNode, My_Favorites);
						
							if (!My_Favorites.IsExpanded)
								My_Favorites.Expand();
						
							string currentProfile = CurrentAutoCADProfile();
						
							int CurrentKeys = (Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValueNames().Length/3);
						
							Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + CurrentKeys, linkPath);
							Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + CurrentKeys + "Display", linkName);
							Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + CurrentKeys + "Ext", "");
						
						}
					
						break;
					case "Properties":
						string files = "";
					
						if (this.ActiveControl == this.lsvExplorer)
						{
							if (this.lsvExplorer.SelectedItems.Count > 0)
							{
								foreach(ListViewItem tmpItm in this.lsvExplorer.SelectedItems)
									files += currentDirectoy() + tmpItm.Text + "\0";
							}
							else
								files = currentDirectoy();
						}
						else
							files = directoyFromNode(My_RightClickNode);
					
						showProperties(files + "\0");
						break;
					case "Paste":
						if (this.ActiveControl == this.lsvExplorer)
							//paste(currentDirectoy());
							paste((My_PasteFolder == "" ? currentDirectoy() : currentDirectoy() + "\\" + My_PasteFolder));
						else
							paste(directoyFromNode(My_RightClickNode));
						break;
					case "Remove":
						try
						{
						
							if (My_RightClickNode != null)
							{
							
								string currentProfile = CurrentAutoCADProfile();
								bool foundItNowFix = false;
							
								int i = 0;
								for (i = 0; i < 1000; i++)
								{
								
									string FavPath = "";
								
									try
									{
										FavPath = Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValue("PlacesOrder" + i).ToString();
										if (FavPath != "")
										{
											if (FavPath == My_RightClickNode.Tag.ToString())
											{
												foundItNowFix = true;
												Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").DeleteValue("PlacesOrder" + i);
												Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").DeleteValue("PlacesOrder" + i + "Display");
												Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").DeleteValue("PlacesOrder" + i + "Ext");
											}
											else if(foundItNowFix)
											{
												Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + (i-1), Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValue("PlacesOrder" + i).ToString());
												Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + (i-1) + "Display", Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValue("PlacesOrder" + i + "Display").ToString());
												Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + (i-1) + "Ext", Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValue("PlacesOrder" + i + "Ext").ToString());
											}
										}
									}
									catch
									{
										break;
									}
								
								}
							
								try
								{
									if (foundItNowFix)
									{
										Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").DeleteValue("PlacesOrder" + (i-1));
										Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").DeleteValue("PlacesOrder" + (i-1) + "Display");
										Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").DeleteValue("PlacesOrder" + (i-1) + "Ext");
									}
								}
								catch{}
							
								My_RightClickNode.Remove();
							
							}
						}
						catch (Exception WTF)
						{
							System.Diagnostics.Trace.WriteLine(WTF.Message);
						}
						break;
					case "Folder":
						if (((MenuItem)((MenuItem)sender).Parent).Text == "New")
							CreateFolder();	
						break;
					case "Text File":
						if (((MenuItem)((MenuItem)sender).Parent).Text == "New")
							CreateTextFile();
						break;
					case "Shortcut":
						CreateNewShortcut();
						break;
					case "Paste Shortcut":
						pasteShortcut();
						break;
					case "Copy":
						if (this.ActiveControl == this.lsvExplorer)
							copy();
						else
							copy(My_RightClickNode);
						break;
					case "Cut":
						if (this.ActiveControl == this.lsvExplorer)
							cut();
						else
							cut(My_RightClickNode);
						break;
					case "Create Shortcut":
						createShortcut();
						break;
					case "Delete":
						if (this.ActiveControl == this.lsvExplorer)
							delete(false);
						else
							delete(false, My_RightClickNode);
						break;
					case "Rename":
						if (this.ActiveControl == this.lsvExplorer)
							rename();	
						else
							My_RightClickNode.BeginEdit();					
						break;
					case "Open":
						if (this.ActiveControl == this.lsvExplorer)
							executeFile();
						else
						{
							My_RightClickNode.Expand();
							this.trvExplorer.SelectedNode = My_RightClickNode;
							My_RightClickNode.EnsureVisible();
						}
						break;
					case "Open With":
						executeWith();
						break;
					case "Large Icons":
						this.currentView = wdViews.LargeIcon;
						break;
					case "Small Icons":
						this.currentView = wdViews.SmallIcon;
						break;
					case "List":
						this.currentView = wdViews.List;
						break;
					case "Details":
						this.currentView = wdViews.Details;
						break;
					case "Thumbnails":
						this.currentView = wdViews.Thumbnail;
						break;
					default:
						break;
				}
			}
			
		}
		
		
		private void fswCurrentDirectory_Deleted(object sender, System.IO.FileSystemEventArgs e)
		{
			
			foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
			{
				if(tmpItem.Text.ToLower() == e.Name.ToLower())
				{
					tmpItem.Remove();
					break;
				}
			}
			
			TreeNode tmpNode = new TreeNode(e.Name, this.containsImage("Folder"), this.containsImage("Folder"));
			tmpNode.Tag = e.FullPath;
			
		}
		
		private void fswCurrentDirectory_Created(object sender, System.IO.FileSystemEventArgs e)
		{
			try
			{
				int iconNum = 1;
				if (Directory.Exists(e.FullPath))
				{
					
					ListViewItem tmpItem = this.lsvExplorer.Items.Add(new ListViewItem(e.Name, 0));
					tmpItem.SubItems.Add("");
					tmpItem.SubItems.Add("File Folder");
					tmpItem.SubItems.Add(File.GetLastWriteTime(e.FullPath).ToString());
					tmpItem.SubItems.Add(File.GetCreationTime(e.FullPath).ToString());
					
				}
				else
				{
					
					string tmpFT = "";
					string tmpDN = "";
					string containedImage = e.FullPath.ToUpper();
					
					if (My_ImageArray.Contains(e.FullPath.ToUpper().Substring(e.FullPath.Length - 3,3)))
					{
						iconNum = (int)My_ImageArray[e.FullPath.ToUpper().Substring(e.FullPath.Length - 3,3)];
						tmpFT = (string)My_FileType[e.FullPath.ToUpper().Substring(e.FullPath.Length - 3,3)];
					}
					else
					{
						
						string iconPathTmp = (containedImage.Length > 3 ? containedImage : "C:\\test." + containedImage);
						Icon tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, false);
						if (tmpIco != null)
						{
							this.imgIcons.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
							try
							{
								My_ImageArray.Add(containedImage.ToUpper(), this.imgIcons.Images.Count - 1);
								My_FileType.Add(containedImage.ToUpper(), tmpFT);
							}
							catch{}
							iconNum = this.imgIcons.Images.Count - 1;
						}
						else
							iconNum = this.containsImage("Unknown");
						
						tmpIco = null;
						tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, true);
						if (tmpIco != null)
						{
							this.imgIconsLarge.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
							this.imgThumbNails.Images.Add(tmpIco);
							iconNum = this.imgIconsLarge.Images.Count - 1;
						}
						else
							iconNum = this.containsImage("Unknown");
						
						//						this.imgIcons.Images.Add(wdExtractIcon.GetIcon("c:\\test." + e.FullPath.ToUpper().Substring(e.FullPath.Length - 3, 3), out tmpFT, out tmpDN)); // ExtractIcon.GetIcon("C:\\Swap", true));
						//						My_ImageArray.Add(e.FullPath.ToUpper().Substring(e.FullPath.Length - 3, 3), this.imgIcons.Images.Count - 1);
						//						My_FileType.Add(e.FullPath.ToUpper().Substring(e.FullPath.Length - 3, 3), tmpFT);
						//						iconNum = this.imgIcons.Images.Count - 1;
					}
					
					string fullSize = "Unknown Size";
					try
					{
						FileInfo tmpFI = new FileInfo(e.FullPath);
						if (tmpFI != null)
						{ 
							
							int TmpSize = (int)tmpFI.Length; 
							
							if (TmpSize > 999 && TmpSize < 1000000000)
							{
								TmpSize = TmpSize / 1000;
								if (TmpSize > 1000)
									fullSize = TmpSize.ToString("0,000") + " KB";
								else
								{
									fullSize = TmpSize.ToString("0") + " KB";
								}
							}
							else if(TmpSize > 1000000000)
							{
								TmpSize = TmpSize / 1000;
								fullSize = TmpSize.ToString("0,000,000") + " KB";
							}
							else if(TmpSize > 1)
								fullSize = "1 KB";
							else
								fullSize = "0 KB";
							
						}
						
						ListViewItem tmpItem = this.lsvExplorer.Items.Add(new ListViewItem(e.Name, iconNum));  
						tmpItem.SubItems.Add(fullSize);
						tmpItem.SubItems.Add(tmpFT);
						tmpItem.SubItems.Add(File.GetLastWriteTime(e.FullPath).ToString()); //dateFormat(((FindFiles.WIN32_FIND_DATA)newFiles[i]).ftLastWriteTime));
						tmpItem.SubItems.Add(File.GetCreationTime(e.FullPath).ToString()); //dateFormat(((FindFiles.WIN32_FIND_DATA)newFiles[i]).ftCreationTime));
						
					}
					catch (Exception WTF)
					{
						Trace.WriteLine("fswCurrentDirectory_Changed : " + WTF.Message + "\r\n" + WTF.StackTrace);
					}
					
				}
			}
			catch (Exception la)
			{
				Trace.WriteLine(la.Message);
			}
			
		}
		
		private void fswCurrentDirectory_Renamed(object sender, System.IO.RenamedEventArgs e)
		{
			foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
			{
				if(tmpItem.Text.ToLower() == e.OldName.ToLower())
				{
					int iconNum = 0;
					string tmpFT = "";
					string tmpDN = "";
					string containedImage = e.FullPath;
					
					if (My_ImageArray.Contains(e.FullPath.ToUpper().Substring(e.FullPath.Length - 3,3)))
					{
						iconNum = (int)My_ImageArray[e.FullPath.ToUpper().Substring(e.FullPath.Length - 3,3)];
						tmpFT = (string)My_FileType[e.FullPath.ToUpper().Substring(e.FullPath.Length - 3,3)];
					}
					else
					{
						
						string iconPathTmp = (containedImage.Length > 3 ? containedImage : "C:\\test." + containedImage);
						Icon tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, false);
						if (tmpIco != null)
						{
							this.imgIcons.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
							My_ImageArray.Add(containedImage.ToUpper().Substring(e.FullPath.Length - 3,3), this.imgIcons.Images.Count - 1);
							My_FileType.Add(containedImage.ToUpper().Substring(e.FullPath.Length - 3,3), tmpFT);
							iconNum = this.imgIcons.Images.Count - 1;
						}
						else
							iconNum = this.containsImage("Unknown");
						
						tmpIco = null;
						tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, true);
						if (tmpIco != null)
						{
							this.imgIconsLarge.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
							this.imgThumbNails.Images.Add(tmpIco);
							iconNum = this.imgIcons.Images.Count - 1;
						}
						else
							iconNum = this.containsImage("Unknown");
						
						//						this.imgIcons.Images.Add(wdExtractIcon.GetIcon("c:\\test." + e.FullPath.ToUpper().Substring(e.FullPath.Length - 3, 3), out tmpFT, out tmpDN)); // ExtractIcon.GetIcon("C:\\Swap", true));
						//						My_ImageArray.Add(e.FullPath.ToUpper().Substring(e.FullPath.Length - 3, 3), this.imgIcons.Images.Count - 1);
						//						My_FileType.Add(e.FullPath.ToUpper().Substring(e.FullPath.Length - 3, 3), tmpFT);
						//						iconNum = this.imgIcons.Images.Count - 1;
					}
					
					string fullSize = "Unknown Size";
					
					try
					{
						FileInfo tmpFI = new FileInfo(e.FullPath);
						if (tmpFI != null)
						{ 
							
							int TmpSize = (int)tmpFI.Length; 
							
							if (TmpSize > 999 && TmpSize < 1000000000)
							{
								TmpSize = TmpSize / 1000;
								if (TmpSize > 1000)
									fullSize = TmpSize.ToString("0,000") + " KB";
								else
								{
									fullSize = TmpSize.ToString("0") + " KB";
								}
							}
							else if(TmpSize > 1000000000)
							{
								TmpSize = TmpSize / 1000;
								fullSize = TmpSize.ToString("0,000,000") + " KB";
							}
							else if(TmpSize > 1)
								fullSize = "1 KB";
							else
								fullSize = "0 KB";
							
						}
						
						tmpItem.ImageIndex = iconNum;
						if (tmpItem.Text.ToLower() != e.Name.ToLower())
							tmpItem.Text = e.Name;
						
						tmpItem.SubItems[1].Text = fullSize;
						
					}
					catch (Exception WTF)
					{
						Trace.WriteLine("fswCurrentDirectory_Changed : " + WTF.Message + "\r\n" + WTF.StackTrace);
					}
					
					break;
				}
			}
		}
		
		private void fswCurrentDirectory_Changed(object sender, System.IO.FileSystemEventArgs e)
		{
			foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
			{
				if(tmpItem.Text.ToLower() == e.Name.ToLower())
				{
					
					string fullSize = "Unknown Size";
					
					try
					{
						FileInfo tmpFI = new FileInfo(e.FullPath);
						if (tmpFI != null)
						{ 
							
							int TmpSize = (int)tmpFI.Length; 
							
							if (TmpSize > 999 && TmpSize < 1000000000)
							{
								TmpSize = TmpSize / 1000;
								if (TmpSize > 1000)
									fullSize = TmpSize.ToString("0,000") + " KB";
								else
								{
									fullSize = TmpSize.ToString("0") + " KB";
								}
							}
							else if(TmpSize > 1000000000)
							{
								TmpSize = TmpSize / 1000;
								fullSize = TmpSize.ToString("0,000,000") + " KB";
							}
							else if(TmpSize > 1)
								fullSize = "1 KB";
							else
								fullSize = "0 KB";
							
						}
						
						tmpItem.SubItems[1].Text = fullSize;
						tmpItem.SubItems[3].Text = tmpFI.LastWriteTime.ToLocalTime().ToShortDateString() + " " + tmpFI.LastWriteTime.ToLocalTime().ToShortTimeString();
						tmpItem.SubItems[4].Text = tmpFI.CreationTime.ToLocalTime().ToShortDateString() + " " + tmpFI.LastWriteTime.ToLocalTime().ToShortTimeString();
						
					}
					catch (Exception WTF)
					{
						Trace.WriteLine("fswCurrentDirectory_Changed : " + WTF.Message + "\r\n" + WTF.StackTrace);
					}
					
					break;
					
				}
			}
		}
		
		
		private void lsvExplorer_BeforeLabelEdit(object sender, System.Windows.Forms.LabelEditEventArgs e)
		{
			
			if (BeginRenameFile != null)
			{
				BeginRenameFile(sender, ref e);
				if (this.lsvExplorer.Items[e.Item].ImageIndex == this.containsImage("Folder"))
				{
					if (Directory.Exists(e.Label))
						e.CancelEdit = true;
				}
				else
				{
					if (File.Exists(e.Label))
						e.CancelEdit = true;
				}
			}
			else
			{
				if (this.lsvExplorer.Items[e.Item].ImageIndex == this.containsImage("Folder"))
				{
					if (Directory.Exists(e.Label))
						e.CancelEdit = true;
				}
				else
				{
					if (File.Exists(e.Label))
						e.CancelEdit = true;
				}
			}
						
		}
		
		private void lsvExplorer_AfterLabelEdit(object sender, System.Windows.Forms.LabelEditEventArgs e)
		{
			
			if (e.Label == null || this.lsvExplorer.Items[e.Item].Text.ToLower() == e.Label.ToLower())
				return;
			
			string directory = currentDirectoy();
			
			if (EndRenameFile != null)
			{
				
				EndRenameFile(sender, ref e);
				
				if (e.CancelEdit)
					return;
				
				if (this.lsvExplorer.Items[e.Item].ImageIndex == this.containsImage("Folder"))
					e.CancelEdit = !this.renameFileFolder(directory + this.lsvExplorer.Items[e.Item].Text, directory + e.Label);
				else
					e.CancelEdit = !this.renameFileFolder(directory + this.lsvExplorer.Items[e.Item].Text, directory + e.Label);
				
			}
			else
			{
				if (this.lsvExplorer.Items[e.Item].ImageIndex == this.containsImage("Folder"))
					e.CancelEdit = !this.renameFileFolder(directory + this.lsvExplorer.Items[e.Item].Text, directory + e.Label);
				else
					e.CancelEdit = !this.renameFileFolder(directory + this.lsvExplorer.Items[e.Item].Text, directory + e.Label);
			}
			
			if (e.CancelEdit)
				this.lsvExplorer.Items[e.Item].BeginEdit();
						
		}
		private void lsvExplorer_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			
			switch(e.KeyCode)
			{
				case Keys.F2:
					this.lsvExplorer.SelectedItems[0].BeginEdit();
					break;
				case Keys.Delete:
					delete(e.Shift);
					break;
				case Keys.Enter:
					if (My_KeyDownFirst)
						executeFileThread();
					break;
				default:
					break;
			}
			
			My_KeyDownFirst = false;
			
		}
		private void lsvExplorer_DoubleClick(object sender, System.EventArgs e)
		{
			
            //if (this.lsvExplorer.SelectedItems.Count > 0 && this.trvExplorer.SelectedNode != null && this.trvExplorer.SelectedNode.ImageIndex == this.containsImage("My Computer"))
            //    this.browse(this.lsvExplorer.SelectedItems[0].Text.Substring(this.lsvExplorer.SelectedItems[0].Text.Length-3,2) + "\\");
            //else
            //{
            //    string directory = currentDirectoy();
				
                if (this.lsvExplorer.SelectedItems.Count > 0)
                {
                    executeFile();
					
                    bool alreadyFoundFolder = false;
                    for(int i = 0; i < this.lsvExplorer.SelectedItems.Count; i++)
                    {
                        if (this.lsvExplorer.SelectedItems[i].ImageIndex == this.containsImage("Folder"))
                        {
                            if (alreadyFoundFolder != true)
                            {
                                alreadyFoundFolder = true;
								
                                if (this.trvExplorer.SelectedNode.Nodes.Count <= 0)
                                {
                                    this.trvExplorer.Nodes.Add(new TreeNode("Searching..."));
                                }
								
                                if (this.trvExplorer.SelectedNode.Nodes[0].Text == "Searching...")
                                {
                                    this.trvExplorer.SelectedNode.Nodes[0].Text = "Searching...";
                                    FindFiles tmpFind = new FindFiles(this.trvExplorer.SelectedNode);
                                    tmpFind.expandNodeWait();
                                }
								
                                foreach(TreeNode tmpNode in this.trvExplorer.SelectedNode.Nodes)
                                {
                                    if (tmpNode.Text.ToUpper() == this.lsvExplorer.SelectedItems[i].Text.ToUpper())
                                    {
                                        this.trvExplorer.SelectedNode = tmpNode;
                                        break;
                                    }
                                }
                            }
                        }
                    }
                }
            //}
			
		}
		private void lsvExplorer_Validated(object sender, System.EventArgs e)
		{
			if (My_Loaded)
			{
				foreach(ColumnHeader tmpCH in this.lsvExplorer.Columns)
				{
					try
					{
						Registry.CurrentUser.CreateSubKey("Software\\WD\\Explorer").SetValue(tmpCH.Text + "ColumnWidth", tmpCH.Width);
					}
					catch{}
				}
			}
		}
		private void lsvExplorer_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			My_KeyDownFirst = true;
			if (e.Modifiers == Keys.Control)
			{
				if(e.KeyCode == Keys.A)
					SelectAll();
				else if(e.KeyCode == Keys.C)
					copy();
				else if(e.KeyCode == Keys.X)
					cut();
				else if(e.KeyCode == Keys.V)
				{
					My_PasteFolder = "";
					//if (this.lsvExplorer.SelectedItems.Count > 0)
					//My_PasteFolder = (this.lsvExplorer.SelectedItems[0].ImageIndex == containsImage("Folder") ? this.lsvExplorer.SelectedItems[0].Text : "");
					paste((My_PasteFolder == "" ? currentDirectoy() : currentDirectoy() + "\\" + My_PasteFolder));
				}
			}
			else if(e.KeyCode == Keys.F5)
				this.Refresh();
		}
		
		private void lsvExplorer_SizeChanged(object sender, System.EventArgs e)
		{
		
		}

		private void lsvExplorer_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			
		}
		private void lsvExplorer_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			
			My_DragDistance = 0;
			My_StopDragging = false;
			
			if (this.trvExplorer.SelectedNode != null && (this.trvExplorer.SelectedNode.ImageIndex == this.containsImage("My Computer") || this.trvExplorer.SelectedNode.ImageIndex == this.containsImage("Favorites") || this.trvExplorer.SelectedNode.ImageIndex == this.containsImage("My Network Places")))
				return;
			
			if (e.Button == MouseButtons.Right)
			{
				this.ctmFiles.MenuItems.Clear();
				
				if (this.lsvExplorer.SelectedItems.Count > 0)
				{
					
					//					MenuItem SendTo = new MenuItem("Send To");
					//					foreach(String FileName in Directory.GetFiles(Environment.GetEnvironmentVariable("USERPROFILE") + "\\sendto"))
					//						SendTo.MenuItems.Add(new MenuItem(Path.GetFileNameWithoutExtension(FileName), new EventHandler(mnuEvents)));
					
					try
					{
						
						My_PasteFolder = "";
						My_PasteFolder = (this.lsvExplorer.GetItemAt(e.X,e.Y).ImageIndex == containsImage("Folder") ? this.lsvExplorer.GetItemAt(e.X,e.Y).Text : "");
						
						this.ctmFiles.MenuItems.Add(new MenuItem("Open", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Open With", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Add To Favorites", new EventHandler(mnuEvents)));
						//					this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						//					this.ctmFiles.MenuItems.Add(SendTo);
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						MenuItem filZip = new MenuItem("Filzip");
						filZip.MenuItems.Add(new MenuItem("Add To Zip...", new EventHandler(mnuEvents)));
						filZip.MenuItems.Add(new MenuItem("Add To \"" + Path.GetFileNameWithoutExtension(this.lsvExplorer.SelectedItems[0].Text) + ".zip\"", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(filZip);
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						this.ctmFiles.MenuItems.Add(new MenuItem("Cut", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Copy", new EventHandler(mnuEvents)));
						
						if (Clipboard.GetDataObject().GetDataPresent(DataFormats.FileDrop) && this.lsvExplorer.GetItemAt(e.X, e.Y).ImageIndex == containsImage("Folder"))
							this.ctmFiles.MenuItems.Add(new MenuItem("Paste", new EventHandler(mnuEvents)));
						
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						this.ctmFiles.MenuItems.Add(new MenuItem("Create Shortcut", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Delete", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Rename", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						this.ctmFiles.MenuItems.Add(new MenuItem("Properties", new EventHandler(mnuEvents)));
						this.ctmFiles.Show((Control)sender, new Point(e.X,e.Y));
						
					}
					catch (Exception WTF)
					{
						Trace.WriteLine("lsvExplorer_MouseUp : " + WTF.Message + "\r\n" + WTF.StackTrace);
					}
				}
				else
				{
					
					MenuItem View = new MenuItem("View");
					
					MenuItem LargeI = new MenuItem("Large Icons", new EventHandler(mnuEvents));
					LargeI.Checked = (this.currentView == wdViews.LargeIcon ? true : false);
					View.MenuItems.Add(LargeI);
					MenuItem SmallI = new MenuItem("Small Icons", new EventHandler(mnuEvents));
					SmallI.Checked = (this.currentView == wdViews.SmallIcon ? true : false);
					View.MenuItems.Add(SmallI);
					MenuItem ListI = new MenuItem("List", new EventHandler(mnuEvents));
					ListI.Checked = (this.currentView == wdViews.List ? true : false);
					View.MenuItems.Add(ListI);
					MenuItem DetailI = new MenuItem("Details", new EventHandler(mnuEvents));
					DetailI.Checked = (this.currentView == wdViews.Details ? true : false);
					View.MenuItems.Add(DetailI);
					MenuItem ThumbnailsI = new MenuItem("Thumbnails", new EventHandler(mnuEvents));
					ThumbnailsI.Checked = (this.currentView == wdViews.Thumbnail ? true : false);
					View.MenuItems.Add(ThumbnailsI);
					
					this.ctmFiles.MenuItems.Add(View);
					this.ctmFiles.MenuItems.Add(new MenuItem("-"));
					this.ctmFiles.MenuItems.Add(new MenuItem("Refresh", new EventHandler(mnuEvents)));
					this.ctmFiles.MenuItems.Add(new MenuItem("-"));
					MenuItem Paste = new MenuItem("Paste", new EventHandler(mnuEvents));
					Paste.Enabled = (Clipboard.GetDataObject().GetDataPresent(DataFormats.FileDrop) ? true : false);
					MenuItem PasteShort = new MenuItem("Paste Shortcut", new EventHandler(mnuEvents));
					PasteShort.Enabled = (Clipboard.GetDataObject().GetDataPresent(DataFormats.FileDrop) ? true : false);
					this.ctmFiles.MenuItems.Add(Paste);
					this.ctmFiles.MenuItems.Add(PasteShort);
					MenuItem UD = new MenuItem("Undo Delete", new EventHandler(mnuEvents));
					UD.Enabled = false;
					this.ctmFiles.MenuItems.Add(UD);
					this.ctmFiles.MenuItems.Add(new MenuItem("-"));
					
					MenuItem NewStuff = new MenuItem("New");
					NewStuff.MenuItems.Add("Folder", new EventHandler(mnuEvents));
					NewStuff.MenuItems.Add("Shortcut", new EventHandler(mnuEvents));
					NewStuff.MenuItems.Add("-");
					NewStuff.MenuItems.Add("Text File", new EventHandler(mnuEvents));
					
					this.ctmFiles.MenuItems.Add(NewStuff);
					this.ctmFiles.MenuItems.Add(new MenuItem("-"));
					this.ctmFiles.MenuItems.Add(new MenuItem("Properties", new EventHandler(mnuEvents)));
					this.ctmFiles.Show((Control)sender, new Point(e.X,e.Y));
					
				}
			}
		}
		private void lsvExplorer_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			
			if (this.trvExplorer.SelectedNode != null && this.trvExplorer.SelectedNode.ImageIndex == this.containsImage("My Computer"))
				return;
			
			if (e.Button == MouseButtons.Left && !My_StopDragging)
			{
				
				My_DragDistance += 1;
				if (My_DragDistance > 5)
				{
					My_StopDragging = true;
					string directory = currentDirectoy();
					try
					{
						string[] tmpFiles = new string[this.lsvExplorer.SelectedItems.Count];
						for (int i = 0; i < this.lsvExplorer.SelectedItems.Count; i++)
							tmpFiles[i] = directory + this.lsvExplorer.SelectedItems[i].Text;
						
						IDataObject data = new DataObject(DataFormats.FileDrop, tmpFiles);
						
						this.lsvExplorer.DoDragDrop(data, DragDropEffects.All | DragDropEffects.Link);
					}
					catch{}
				}
				
			}
			else if (My_DragDistance != 0)
			{
				My_StopDragging = false;
				My_DragDistance = 0;
				My_DragFolder = null;
			}
		}
		
		private void lsvExplorer_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			
			string[] FilesTo = (string[])e.Data.GetData(DataFormats.FileDrop);
			
			ListViewItem selItem = this.lsvExplorer.GetItemAt(this.lsvExplorer.PointToClient(new Point(e.X, e.Y)).X, this.lsvExplorer.PointToClient(new Point(e.X, e.Y)).Y);
			string fromPath = FilesTo[0].Replace(FilesTo[0].Split(new char[] {'\\'})[FilesTo[0].Split(new char[] {'\\'}).Length-1], "");
			
			if (FilesTo.Length > 0 && ((selItem != null && selItem.ImageIndex == containsImage("Folder")) ))
			{
				
				string tmpDir = "";
				if (selItem != null && selItem.ImageIndex == containsImage("Folder"))
					tmpDir = currentDirectoy() + selItem.Text + "\\";
				else
					tmpDir = currentDirectoy();
				
				switch (e.Effect)
				{
					case DragDropEffects.Move:
						moveToFolder(FilesTo, tmpDir);
						break;
					case DragDropEffects.Copy:
						copyToFolder(FilesTo, tmpDir);
						break;
					case DragDropEffects.Link:
						break;
					default:
						break;
				}
				
			}
			
		}
		
		private void lsvExplorer_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			
			foreach(string tmpF in e.Data.GetFormats())
			{
				Object tmpObj = e.Data.GetData(tmpF);
				Trace.WriteLine(tmpObj.ToString());
			}
			
			if (!e.Data.GetDataPresent(DataFormats.FileDrop))
			{
				e.Effect = DragDropEffects.None;
				return;
			}
			
			if ((e.KeyState & (8+32)) == (8+32) && (e.AllowedEffect & DragDropEffects.Link) == DragDropEffects.Link) 
				e.Effect = DragDropEffects.Link;
			else if ((e.KeyState & 32) == 32 && (e.AllowedEffect & DragDropEffects.Link) == DragDropEffects.Link) 
				e.Effect = DragDropEffects.Link;
			else if ((e.KeyState & 4) == 4 && (e.AllowedEffect & DragDropEffects.Move) == DragDropEffects.Move) 
				e.Effect = DragDropEffects.Move;
			else if ((e.KeyState & 8) == 8 && (e.AllowedEffect & DragDropEffects.Copy) == DragDropEffects.Copy) 
				e.Effect = DragDropEffects.Copy;
				//			else if ((e.AllowedEffect & DragDropEffects.Move) == DragDropEffects.Move)  
				//				e.Effect = DragDropEffects.Move;
			else
				e.Effect = DragDropEffects.Copy;
			
		}
		
		private void lsvExplorer_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
		
			this.lsvExplorer.ListViewItemSorter = My_ColumnSorter;
			
			if ( e.Column == My_ColumnSorter.SortColumn )
			{
				if (My_ColumnSorter.Order == System.Windows.Forms.SortOrder.Ascending)
                    My_ColumnSorter.Order = System.Windows.Forms.SortOrder.Descending;
				else
                    My_ColumnSorter.Order = System.Windows.Forms.SortOrder.Ascending;
			}
			else
			{
				My_ColumnSorter.SortColumn = e.Column;
                My_ColumnSorter.Order = System.Windows.Forms.SortOrder.Ascending;
			}
			this.lsvExplorer.Sort();
			
		}
		
		
		private void trvExplorer_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			
			try
			{
				if (this.trvExplorer.SelectedNode != null && this.trvExplorer.SelectedNode.ImageIndex == this.containsImage("My Computer"))
				{
				
					this.lsvExplorer.Items.Clear();
				
					TreeNode tmpNode = My_Computer.FirstNode;
					do
					{
						ListViewItem tmpItm = new ListViewItem(tmpNode.Text);
						tmpItm.ImageIndex = tmpNode.ImageIndex;
						this.lsvExplorer.Items.Add(tmpItm);
					}
					while ((tmpNode = tmpNode.NextNode) != null);
				
				}
				else
				{
				
					string tmpDir = currentDirectoy();
				
					if(DirectoryChanged != null)
						DirectoryChanged(tmpDir, this.imgIcons.Images[e.Node.ImageIndex]);
				
					Thread watchFolder = new Thread(new ThreadStart(watchFolderThread));
					watchFolder.Name = "Do watch";
					watchFolder.Start();
				
					this.lsvExplorer.ListViewItemSorter = null;
                    this.My_ColumnSorter.Order = System.Windows.Forms.SortOrder.Ascending;
					this.My_ColumnSorter.SortColumn = 0;
				
					if (e.Node.Nodes.Count > 0)
					{
					
						if (My_FindFiles != null)
							My_FindFiles.cancel();
					
						My_StillShowProgress += 1;
						if (ShowProgress != null)
							ShowProgress();
					
						this.lsvExplorer.Items.Clear();
						My_FindFiles = new FindFiles(e.Node);
						My_FindFiles.selectNode();
					
					}
					else
					{
					
						if (My_FindFiles != null)
							My_FindFiles.cancel();
					
						My_StillShowProgress += 1;
						if (ShowProgress != null)
							ShowProgress();
					
						this.lsvExplorer.Items.Clear();
						My_FindFiles = new FindFiles(e.Node);
						My_FindFiles.selectNode();
					
					}
				}
			}
            catch (Exception wtf)
            {
                System.Diagnostics.Trace.WriteLine(wtf.Message);
            }
		}
		private void trvExplorer_BeforeExpand(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			
			My_DragDistance = 0;
			
			if (e.Node.ImageIndex == this.containsImage("My Network Places"))
			{
				My_UncPaths = new Hashtable();
				foreach(string nhFile in Directory.GetDirectories(Environment.GetEnvironmentVariable("USERPROFILE") + "\\NetHood"))
				{
					string nnhFile = nhFile.Replace(Environment.GetEnvironmentVariable("USERPROFILE") + "\\NetHood\\", "");
					if (nnhFile.IndexOf(" on ") > -1)
					{
						if (!My_UncPaths.Contains((@"\\" + nnhFile.Split(new char[] {' '})[2] + @"\" + nnhFile.Split(new char[] {' '})[0] + @"\").ToString().ToUpper()))
						{
							TreeNode[] tmpTreeChild = new TreeNode[] {new TreeNode("Searching...", 1, 1)};
							TreeNode tmpNode = new TreeNode(nnhFile, this.containsImage("Folder"), this.containsImage("Folder"), tmpTreeChild);
							tmpNode.Tag = @"\\" + nnhFile.Split(new char[] {' '})[2] + @"\" + nnhFile.Split(new char[] {' '})[0] + @"\";
							this.AddNode(tmpNode, My_NetworkPlaces);
							
							My_UncPaths.Add(tmpNode.Tag.ToString().ToUpper(), tmpNode);
						}
					}
				}
			}
			else
			{
				if (BeginExpand != null)
				{
					BeginExpand(this, ref e);
					if (e.Cancel != true)
					{
						if (e.Node.Nodes[0].Text == "Searching...")
						{
						
							My_StillShowProgress += 1;
							if (ShowProgress != null)
								ShowProgress();
						
							FindFiles tmpFind = new FindFiles(e.Node);
							tmpFind.expandNode();
						
						}
					}
				}
				else
				{
					if (e.Node.Nodes[0].Text == "Searching...")
					{
					
						My_StillShowProgress += 1;
						if (ShowProgress != null)
							ShowProgress();
					
						FindFiles tmpFind = new FindFiles(e.Node);
						tmpFind.expandNode();
					
					}
				}
			}
		}
		private void trvExplorer_BeforeLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			
			if (BeginRenameFile != null)
			{
				if (!Directory.Exists(currentDirectoy()) || this.trvExplorer.SelectedNode.ImageIndex != containsImage("Folder"))
					e.CancelEdit = true;
			}
			else
			{
				if (!Directory.Exists(currentDirectoy()) || this.trvExplorer.SelectedNode.ImageIndex != containsImage("Folder"))
					e.CancelEdit = true;
			}
			
		}
		
		private void trvExplorer_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			
			if (e.Label == null || e.Node.Text.ToLower() == e.Label.ToLower())
				return;
			
			if (e.Node.Parent.Text == "Favorites" && e.Node.Parent.ImageIndex == this.containsImage("Favorites"))
			{
				
				string currentProfile = CurrentAutoCADProfile();
			
				int i = 0;
				for (i = 0; i < 1000; i++)
				{
				
					string FavPath = "";
				
					try
					{
						FavPath = Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValue("PlacesOrder" + i + "Display").ToString();
						if (FavPath != "")
						{
							if (FavPath.ToLower() == e.Node.Text.ToLower())
							{
								Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + i + "Display", e.Label);
								break;
							}
						}
					}
					catch
					{
						break;
					}
				
				}
				
			}
			else
			{
				
				string directory = currentDirectoy();
				
				if (!this.renameFileFolder(directory.Substring(0,directory.Length-1), directory.Replace("\\" + e.Node.Text + "\\", "\\" + e.Label)))
					e.CancelEdit = true;
				else
					e.Node.Tag = e.Label;
				
			}
			
		}
		private void trvExplorer_Resize(object sender, System.EventArgs e)
		{
			if (My_Loaded)
			{
				try
				{
					Registry.CurrentUser.CreateSubKey("Software\\WD\\Explorer").SetValue("treeWidth", this.trvExplorer.Width);
				}
				catch{}
			}
		}
		private void trvExplorer_BeforeCollapse(object sender, System.Windows.Forms.TreeViewCancelEventArgs e)
		{
			if(e.Node.Parent == null)
				e.Cancel = true;
		}
		
		private void trvExplorer_DragOver(object sender, System.Windows.Forms.DragEventArgs e)
		{
			
			if (!e.Data.GetDataPresent(DataFormats.FileDrop))
			{
				e.Effect = DragDropEffects.None;
				return;
			}
			
			if ((e.KeyState & (8+32)) == (8+32) && (e.AllowedEffect & DragDropEffects.Link) == DragDropEffects.Link)
				e.Effect = DragDropEffects.Link;
			else if ((e.KeyState & 32) == 32 && (e.AllowedEffect & DragDropEffects.Link) == DragDropEffects.Link)
				e.Effect = DragDropEffects.Link;
			else if ((e.KeyState & 4) == 4 && (e.AllowedEffect & DragDropEffects.Move) == DragDropEffects.Move)
				e.Effect = DragDropEffects.Move;
			else if ((e.KeyState & 8) == 8 && (e.AllowedEffect & DragDropEffects.Copy) == DragDropEffects.Copy)
				e.Effect = DragDropEffects.Copy;
			else
				e.Effect = DragDropEffects.Copy;
			
			
			
		}
		
		private void trvExplorer_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			
			string[] FilesTo = (string[])e.Data.GetData(DataFormats.FileDrop);
			
			TreeNode selNode = this.trvExplorer.GetNodeAt(this.trvExplorer.PointToClient(new Point(e.X, e.Y)));
			
			if (selNode.Text == "Favorites" && selNode.ImageIndex == this.containsImage("Favorites"))
			{
				for (int i = 0; i < FilesTo.Length; i++)
				{
					if (System.IO.Directory.Exists(FilesTo[0]))
					{
						
						string linkPath = FilesTo[i];
						if(linkPath.EndsWith("\\"))
							linkPath = linkPath.Substring(0,linkPath.Length-2);
						
						string linkName = linkPath.Split(new char[] {'\\'})[linkPath.Split(new char[] {'\\'}).Length-1];
						TreeNode[] tmpTreeChild = new TreeNode[] {new TreeNode("Searching...", 1, 1)};
						TreeNode tmpNode = new TreeNode(linkName, this.containsImage("Folder"), this.containsImage("Folder"), tmpTreeChild);
						tmpNode.Tag = linkPath;
						this.AddNode(tmpNode, My_Favorites);
						
						if (!My_Favorites.IsExpanded)
							My_Favorites.Expand();
						
						string currentProfile = CurrentAutoCADProfile();
						
						int CurrentKeys = (Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValueNames().Length/3);
						
						Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + CurrentKeys, linkPath);
						Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + CurrentKeys + "Display", linkName);
						Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").SetValue("PlacesOrder" + CurrentKeys + "Ext", "");
						
					}
				}
			}
			else
			{
				
				string tmpDir = directoyFromNode(selNode);
				
				if (Directory.Exists(tmpDir))
				{
					switch (e.Effect)
					{
						case DragDropEffects.Move:
							moveToFolder(FilesTo, tmpDir);
							break;
						case DragDropEffects.Copy:
							copyToFolder(FilesTo, tmpDir);
							break;
						case DragDropEffects.Link:
							break;
						default:
							break;
					}
				}
			}
			
		}
		
		private void trvExplorer_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			
			switch(e.KeyCode)
			{
				case Keys.F2:
					this.trvExplorer.SelectedNode.BeginEdit();
					break;
				case Keys.Delete:
					delete(e.Shift);
					break;
				case Keys.F5:
					this.Refresh();
					break;
				default:
					break;
			}
			
		}
		
		private void trvExplorer_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Left && !My_StopDragging)
			{
				
				if (My_DragFolder != null && My_DragFolder.Parent != null && My_DragFolder.Parent != My_Computer && My_DragFolder.Parent != My_NetworkPlaces)
				{
					My_DragDistance += 1;
					if (My_DragDistance > 5)
					{
						My_StopDragging = true;
						string directory = currentDirectoy();
						try
						{
							string[] tmpFiles = new string[1];
							TreeNode tmpNode = My_DragFolder;
							tmpFiles[0] = directoyFromNode(tmpNode);
							tmpFiles[0] = tmpFiles[0].Substring(0,tmpFiles[0].Length-1);
							IDataObject data = new DataObject(DataFormats.FileDrop, tmpFiles);
						
							this.trvExplorer.DoDragDrop(data, DragDropEffects.All | DragDropEffects.Link);
						}
						catch{}
					}
				}
				
			}
			else if (My_DragDistance != 0)
			{
				My_StopDragging = false;
				My_DragDistance = 0;
				My_DragFolder = null;
			}
		}
		private void trvExplorer_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			My_DragDistance = 0;
			My_StopDragging = false;
			
			if (e.Button == MouseButtons.Right)
			{
				
				My_RightClickNode = trvExplorer.GetNodeAt(e.X,e.Y);
				
				if (My_RightClickNode != null && My_RightClickNode.ImageIndex != this.containsImage("Desktop") && My_RightClickNode.ImageIndex != this.containsImage("Favorites") && My_RightClickNode.ImageIndex != this.containsImage("My Computer") && My_RightClickNode.ImageIndex != this.containsImage("My Network Places"))
				{
					if (My_RightClickNode.Parent != null && My_RightClickNode.Parent.Text == "Favorites" && My_RightClickNode.Parent.ImageIndex == this.containsImage("Favorites"))
					{
					
						this.ctmFiles.MenuItems.Clear();
					
						this.ctmFiles.MenuItems.Add(new MenuItem("Open", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						this.ctmFiles.MenuItems.Add(new MenuItem("Remove", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Rename", new EventHandler(mnuEvents)));
						this.ctmFiles.Show((Control)sender, new Point(e.X,e.Y));
					
					}
					else
					{
					
						this.ctmFiles.MenuItems.Clear();
					
						this.ctmFiles.MenuItems.Add(new MenuItem("Open", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Add To Favorites", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						MenuItem filZip = new MenuItem("Filzip");
						filZip.MenuItems.Add(new MenuItem("Add To Zip...", new EventHandler(mnuEvents)));
						filZip.MenuItems.Add(new MenuItem("Add To \"" + My_RightClickNode.Text + ".zip\"", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(filZip);
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						this.ctmFiles.MenuItems.Add(new MenuItem("Cut", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Copy", new EventHandler(mnuEvents)));
					
						if (Clipboard.GetDataObject().GetDataPresent(DataFormats.FileDrop))
							this.ctmFiles.MenuItems.Add(new MenuItem("Paste", new EventHandler(mnuEvents)));
					
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						this.ctmFiles.MenuItems.Add(new MenuItem("Delete", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("Rename", new EventHandler(mnuEvents)));
						this.ctmFiles.MenuItems.Add(new MenuItem("-"));
						this.ctmFiles.MenuItems.Add(new MenuItem("Properties", new EventHandler(mnuEvents)));
						this.ctmFiles.Show((Control)sender, new Point(e.X,e.Y));
					
					}
				}
			}
			
		}
		private void trvExplorer_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			My_DragFolder = trvExplorer.GetNodeAt(new Point(e.X,e.Y));
		}
		#endregion Events
		
		#region get/set variables
		public wdViews currentView
		{
			get { return My_ListView; }
			set 
			{
				My_ListView = value;
				switch(My_ListView)
				{
					case wdViews.Details:
						this.lsvExplorer.View = View.Details;
						break;
					case wdViews.LargeIcon:
						this.lsvExplorer.LargeImageList = this.imgIconsLarge;
						this.lsvExplorer.View = View.LargeIcon;
						break;
					case wdViews.List:
						this.lsvExplorer.View = View.List;
						break;
					case wdViews.SmallIcon:
						this.lsvExplorer.View = View.SmallIcon;
						break;
					case wdViews.Thumbnail:
						this.lsvExplorer.LargeImageList = this.imgThumbNails;
						this.lsvExplorer.View = View.LargeIcon;
						
						ManualResetEvent tmpMRE = new ManualResetEvent(false);
						
						string curDir = this.currentDirectoy();
						if (!curDir.EndsWith("\\"))
							curDir += "\\";
						
						foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
						{
							string containedImage = "";
							containedImage = tmpItem.Text.ToUpper().Substring(tmpItem.Text.Length - 3,3);
							
							if (My_ImageArray.Contains(containedImage))
							{
								
								if (My_ThumbnailExts.Contains(Path.GetExtension(tmpItem.Text.ToLower())) && !My_ImageArray.Contains(curDir + tmpItem.Text))
								{
									ThreadPool.QueueUserWorkItem(new WaitCallback(loadThumbNail), new object[] {containedImage, tmpItem, tmpMRE});
								}
							}
						}
						tmpMRE.Set();
						
						break;
					default:
						break;
				}
			}
		}
		#endregion get/set variables
		
		#region The one And Only BuildControl
		private void buildControl()
		{
			
			My_ImageArray = new Hashtable();
			My_FileType = new Hashtable();
			
			string tmpFT = "";
			string tmpDN = "";
			
			this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon(Environment.GetEnvironmentVariable("SYSTEMROOT").ToString() + "\\", out tmpFT, out tmpDN, true));
			this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon(Environment.GetEnvironmentVariable("SYSTEMROOT").ToString() + "\\", out tmpFT, out tmpDN, true));
			this.imgIcons.Images.Add(wdExtractIcon.GetIcon(Environment.GetEnvironmentVariable("SYSTEMROOT").ToString() + "\\", out tmpFT, out tmpDN, false));
			My_ImageArray.Add("Folder", this.imgIcons.Images.Count - 1);
			My_FileType.Add("Folder", tmpFT);
			
			this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon("c:\\ThisFileShouldntExist.unknown", out tmpFT, out tmpDN, true)); // ExtractIcon.GetIcon("C:\\Swap", true));
			this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon("c:\\ThisFileShouldntExist.unknown", out tmpFT, out tmpDN, true)); // ExtractIcon.GetIcon("C:\\Swap", true));
			this.imgIcons.Images.Add(wdExtractIcon.GetIcon("c:\\ThisFileShouldntExist.unknown", out tmpFT, out tmpDN, false)); // ExtractIcon.GetIcon("C:\\Swap", true));
			My_ImageArray.Add("Unknown", this.imgIcons.Images.Count - 1);
			My_FileType.Add("Unknown", tmpFT);
			
			#region Events
			if (BeginBuildTree != null)
			{
				TreeNode[] newNodes = new TreeNode[0];
				BeginBuildTree(this, ref newNodes);
				for(int i = 0; i < newNodes.Length; i++)
				{
					this.trvExplorer.Nodes.Add(newNodes[i]);
				}
			}
			#endregion Events
			
			#region My Favorites

            TreeNode[] tmpTreeChild = new TreeNode[1];
            TreeNode tmpNode = null;

            this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.FAVORITES, out tmpFT, out tmpDN));
            this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.FAVORITES, out tmpFT, out tmpDN));
            this.imgIcons.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.FAVORITES, out tmpFT, out tmpDN));
            //My_ImageArray.Add("Favorites", this.imgIcons.Images.Count - 1);
            //My_FileType.Add("Favorites", tmpFT);
            //My_Favorites = new TreeNode("Favorites", this.containsImage("Favorites"), this.containsImage("Favorites"));
            //this.AddNode(My_Favorites);
			
//            string currentProfile = CurrentAutoCADProfile();
			
//            try
//            {
				
//                foreach(string tmpProfile in Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles").GetSubKeyNames())
//                {
//                    int ns = 0;
//                    try
//                    {
//                        ns = int.Parse(Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + tmpProfile + "\\Dialogs\\Appload\\Startup").GetValue("NumStartup").ToString());
//                    }
//                    catch
//                    {
//                    }
//                    if (ns > 0)
//                    {
//                        bool alreadyReged = false;
//                        for(int i = 1; i <= ns; i++)
//                        {
//                            if (Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + tmpProfile + "\\Dialogs\\Appload\\Startup").GetValue(ns + "Startup").ToString().ToLower() == (@"C:\wdAutomation\Explorer\wdFileOpen.arx").ToLower())
//                            {
//                                //Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\Appload\\Startup").DeleteSubKey(ns + "Startup");
//                                alreadyReged = true;
//                                break;
//                            }
//                            //						else if(alreadyReged)
//                            //						{
//                            //							Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\Appload\\Startup").SetValue((ns) + "Startup", Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\Appload\\Startup").GetValue((ns + 1) + "Startup"));
//                            //							Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\Appload\\Startup").SetValue("NumStartup", (ns + 1).ToString());
//                            //						}
//                        }
//                        if(!alreadyReged)
//                        {
//                            Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + tmpProfile + "\\Dialogs\\Appload\\Startup").SetValue((ns + 1) + "Startup", "C:\\wdAutomation\\Explorer\\wdFileOpen.arx");
//                            Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + tmpProfile + "\\Dialogs\\Appload\\Startup").SetValue("NumStartup", (ns + 1));
////							Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\Appload\\Startup").DeleteValue((ns) + "Startup");
////							Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\Appload\\Startup").SetValue("NumStartup", (ns + 1).ToString());
//                        }
//                    }
//                    else
//                    {
//                        Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + tmpProfile + "\\Dialogs\\Appload\\Startup").SetValue("1Startup", "C:\\wdAutomation\\Explorer\\wdFileOpen.arx");
//                        Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + tmpProfile + "\\Dialogs\\Appload\\Startup").SetValue("NumStartup", "1");
//                    }
//                }
//            }
//            catch{}
			
//            try
//            {
//                int totalFavs = Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValueNames().Length / 3;
//                for (int i = 0; i < totalFavs; i++)
//                {
					
//                    string FavPath = "";
//                    string FavDisplay = "";
					
//                    try
//                    {
//                        FavPath = Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValue("PlacesOrder" + i).ToString();
//                        if (FavPath != "")
//                        {
//                            FavDisplay = Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles\\" + currentProfile + "\\Dialogs\\AllAnavDialogs").GetValue("PlacesOrder" + i + "Display").ToString();
//                            tmpTreeChild[0] = new TreeNode("Searching...", 1, 1);
//                            tmpNode = new TreeNode(FavDisplay, this.containsImage("Folder"), this.containsImage("Folder"), tmpTreeChild);
//                            tmpNode.Tag = FavPath;
//                            this.AddNode(tmpNode, My_Favorites);
//                        }
//                    }
//                    catch
//                    {
//                        break;
//                    }
					
//                }
//            }
//            catch{}
//            My_Favorites.Expand();
			#endregion My Favorites
			
			#region My Computer
			
			tmpTreeChild = new TreeNode [1];
			tmpNode = null;

#if (DEBUG && TRACE)
			Trace.WriteLine("buildControl: Start My_Computer");
#endif
			
			this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.DESKTOP, out tmpFT, out tmpDN));
			this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.DESKTOP, out tmpFT, out tmpDN));
			this.imgIcons.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.DESKTOP, out tmpFT, out tmpDN));
			My_ImageArray.Add("Desktop", this.imgIcons.Images.Count - 1);
			My_FileType.Add("Desktop", tmpFT);
			My_Desktop = new TreeNode("Desktop", this.containsImage("Desktop"), this.containsImage("Desktop"));
			My_Desktop.Tag = Environment.GetEnvironmentVariable("USERPROFILE") + "\\Desktop\\";
			this.AddNode(My_Desktop);
			
#if (DEBUG && TRACE)
			Trace.WriteLine("buildControl: Start My_Computer Icon ");
#endif

			this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.MYCOMPUTER, out tmpFT, out tmpDN));
			this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.MYCOMPUTER, out tmpFT, out tmpDN));
			this.imgIcons.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.MYCOMPUTER, out tmpFT, out tmpDN));
			My_ImageArray.Add("My Computer", this.imgIcons.Images.Count - 1);
			My_FileType.Add("My Computer", tmpFT);
			My_Computer = new TreeNode("My Computer", this.containsImage("My Computer"), this.containsImage("My Computer"));
			this.AddNode(My_Computer, My_Desktop);
			My_Desktop.Expand();
			
#if (DEBUG && TRACE)
			Trace.WriteLine("buildControl: Start find Drives");
#endif
			
			My_MappedDrives = new Hashtable();
			foreach(string tmpDrive in Environment.GetLogicalDrives())
			{

                if (tmpDrive.ToUpper() != "A:\\")
                {
#if (DEBUG && TRACE)
                    Trace.WriteLine("buildControl: Start GetDriveType " + tmpDrive);
#endif

                    DriveType tmpType = GetDriveType(tmpDrive);

                    this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon(tmpDrive, out tmpFT, out tmpDN, true));
                    this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon(tmpDrive, out tmpFT, out tmpDN, true));
                    this.imgIcons.Images.Add(wdExtractIcon.GetIcon(tmpDrive, out tmpFT, out tmpDN, false));
                    My_ImageArray.Add(tmpDrive, this.imgIcons.Images.Count - 1);
                    My_FileType.Add(tmpDrive, tmpFT);

                    tmpTreeChild[0] = new TreeNode("Searching...", 1, 1);
                    tmpNode = new TreeNode(tmpDN, this.containsImage(tmpDrive), this.containsImage(tmpDrive), tmpTreeChild);
                    tmpNode.Tag = tmpDrive.Substring(0, 2);
                    this.AddNode(tmpNode, My_Computer);
                    My_MappedDrives.Add(tmpDrive.ToUpper(), tmpNode);

#if (DEBUG && TRACE)
                    Trace.WriteLine("buildControl: End GetDriveType");
#endif
                }
			}
			
#if (DEBUG && TRACE)
			Trace.WriteLine("buildControl: Start My_Computer.Expand()");
#endif
			
			My_Computer.Expand();
			#endregion My Computer
			
			#region My Net Work Places
			
			this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.NETWORK, out tmpFT, out tmpDN));
			this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.NETWORK, out tmpFT, out tmpDN));
			this.imgIcons.Images.Add(wdExtractIcon.GetIcon(wdExtractIcon.CSIDL.NETWORK, out tmpFT, out tmpDN));
			My_ImageArray.Add("My Network Places", this.imgIcons.Images.Count - 1);
			My_FileType.Add("My Network Places", tmpFT);
			
			My_NetworkPlaces = new TreeNode("My Network Places", this.containsImage("My Network Places"), this.containsImage("My Network Places"));
			this.AddNode(My_NetworkPlaces, My_Desktop);
			tmpNode = new TreeNode("Searching...", 1,1);
			this.AddNode(tmpNode, My_NetworkPlaces);
			#endregion My Net Work Places
			
			#region Events
			if (EndBuildTree != null)
			{
				TreeNode[] newNodes = new TreeNode[0];
				BeginBuildTree(this, ref newNodes);
				for(int i = 0; i < newNodes.Length; i++)
				{
					this.trvExplorer.Nodes.Add(newNodes[i]);
				}
			}
			#endregion Events
			
			try
			{
				this.trvExplorer.Width = int.Parse(Registry.CurrentUser.CreateSubKey("Software\\WD\\Explorer").GetValue("treeWidth").ToString());
			}
			catch{}
			
			foreach(ColumnHeader tmpCH in this.lsvExplorer.Columns)
			{
				try
				{
					tmpCH.Width = int.Parse(Registry.CurrentUser.CreateSubKey("Software\\WD\\Explorer").GetValue(tmpCH.Text + "ColumnWidth").ToString());
				}
				catch{}
			}

            this.lsvExplorer.View = View.Details;
			My_Loaded = true;
			
		}
		#endregion
		
		#region Functions
		public void filZip(bool AutoName)
		{
			
			string tmpZipFile = "";
			
			if (this.ActiveControl == this.lsvExplorer)
			{
				if (this.lsvExplorer.SelectedItems.Count > 1)
				{
					
					string tmpZipData = "fz_shext_file_list\r\n";
					string curDir = currentDirectoy();
					if (!curDir.EndsWith("\\"))
						curDir += "\\";
					
					foreach (ListViewItem tmpItem in this.lsvExplorer.SelectedItems)
						tmpZipData += curDir + tmpItem.Text + "\r\n";
					
					tmpZipFile = Environment.GetEnvironmentVariable("TEMP") + "\\" + DateTime.Now.Ticks + ".tmp";
					FileStream tmpFS = new FileStream(tmpZipFile, FileMode.Create, FileAccess.Write, FileShare.None);
					byte[] tmpZipFileB = System.Text.Encoding.Default.GetBytes(tmpZipData);
					tmpFS.Write(tmpZipFileB, 0, tmpZipFileB.Length);
					tmpFS.Close();
					
				}
				else
					tmpZipFile = this.currentDirectoy() + "\\" + this.lsvExplorer.SelectedItems[0].Text;
			}
			else
				tmpZipFile = this.directoyFromNode(My_RightClickNode);
			
			Process filZipProc = new Process();
			filZipProc.StartInfo.FileName = "C:\\program files\\Filzip\\filzip.exe";
			filZipProc.StartInfo.Arguments = "/fzsA" + (AutoName ? "z" : "c") + " \"" + tmpZipFile + "\" zip";
			filZipProc.Start();
			
		}
				
		public int addIcon(Icon newIcon, string iconName)
		{
			
			int IconIndex = containsImage(iconName);
			
			if (IconIndex == -1)
			{
				
				this.imgIconsLarge.Images.Add(newIcon);
				this.imgThumbNails.Images.Add(newIcon);
				this.imgIcons.Images.Add(newIcon);
				
				My_ImageArray.Add(iconName, this.imgIcons.Images.Count -1);
				IconIndex = containsImage(iconName);
				
			}
			
			return IconIndex;
			
		}
		public ImageList fileIcons
		{
			get { return imgIcons; }
		}
		public int containsImage(string imageName)
		{
			if (this.My_ImageArray.Contains(imageName))
			{
				return (int)My_ImageArray[imageName];
			}
			else
				return -1;
		}
		public int addImage(string imageName, Image newImage)
		{
			this.imgIconsLarge.Images.Add(newImage);
			this.imgThumbNails.Images.Add(newImage);
			this.imgIcons.Images.Add(newImage);
			this.My_ImageArray.Add(imageName, this.imgIcons.Images.Count-1);
			return this.imgIcons.Images.Count-1;
		}
		
		public void AddNode(TreeNode newNode)
		{
			if (BeginNewNode != null)
			{
				TreeViewCancelEventArgs tmpEA = new TreeViewCancelEventArgs(newNode, false, TreeViewAction.Expand);
				BeginNewNode(this, ref tmpEA); 
				if (!tmpEA.Cancel)
					this.trvExplorer.Nodes.Add(newNode);
			}
			else
				this.trvExplorer.Nodes.Add(newNode);
			
			if (EndNewNode != null)
			{
				TreeViewCancelEventArgs tmpEA = new TreeViewCancelEventArgs(newNode, false, TreeViewAction.Expand);
				EndNewNode(this, ref tmpEA);
			}
			
		}
		public void AddNode(TreeNode newNode, TreeNode parentNode)
		{
			if (BeginNewNode != null)
			{
				TreeViewCancelEventArgs tmpEA = new TreeViewCancelEventArgs(newNode, false, TreeViewAction.Expand);
				BeginNewNode(this, ref tmpEA); 
				if (!tmpEA.Cancel)
				{
					parentNode.Nodes.Add(newNode);
					Application.DoEvents();
				}
			}
			else
				parentNode.Nodes.Add(newNode);			
			
			if (EndNewNode != null)
			{
				TreeViewCancelEventArgs tmpEA = new TreeViewCancelEventArgs(newNode, false, TreeViewAction.Expand);
				EndNewNode(this, ref tmpEA);
			}
			
		}
		
		internal void AddSingleTreeNode(TreeNode newNodes, TreeNode prevNode) 
		{ 
			if (BeginNewNode != null)
			{
				TreeViewCancelEventArgs tmpEA = new TreeViewCancelEventArgs(newNodes, false, TreeViewAction.Expand);
				BeginNewNode(this, ref tmpEA); 
				if (!tmpEA.Cancel)
					prevNode.Nodes.Add(newNodes);
			}
			else
				prevNode.Nodes.Add(newNodes);
			
		} 
		internal void AddTreeViewNode(ArrayList addNodes, TreeNode prevNode) 
		{ 
			
			this.trvExplorer.BeginUpdate();
			
			bool NodeExists = false;
			
			TreeNode tmpRMNode = null;
			if (prevNode.Nodes[0].Text == "Searching...")
				tmpRMNode = prevNode.Nodes[0];
			
			ArrayList tmpArray = new ArrayList();
			ArrayList newNodes = new ArrayList();
			foreach(TreeNode tmpNode in addNodes)
				tmpArray.Add(tmpNode.Text);
			
			tmpArray.Sort();
			
			foreach(string tmpText in tmpArray)
			{
				foreach(TreeNode tmpNode in addNodes)
				{
					if (tmpNode.Text == tmpText && tmpNode.Text.ToLower().IndexOf("_ntfrs_") < 0)
					{
						newNodes.Add(tmpNode);
						break;
					}
				}
			}
			


			for (int i = 0; i < newNodes.Count; i ++)
			{
				NodeExists = false;
				
				if (BeginNewNode != null)
				{
					TreeViewCancelEventArgs tmpEA = new TreeViewCancelEventArgs((TreeNode)newNodes[i], false, TreeViewAction.Expand);
					BeginNewNode(this, ref tmpEA); 
					if (!tmpEA.Cancel)
					{
						if (prevNode.Nodes.Count > 0)
						{
							foreach(TreeNode tmpNode in prevNode.Nodes)
							{
								if (tmpNode.Text != "Searching..." && tmpNode.Tag.ToString().ToUpper() == ((TreeNode)newNodes[i]).Tag.ToString().ToUpper())
								{
									NodeExists = true;
									break;
								}
							}
						}
						if (!NodeExists)
							prevNode.Nodes.Add((TreeNode)newNodes[i]);
					}
				}
				else
				{
					if (prevNode.Nodes.Count > 0)
					{
						foreach(TreeNode tmpNode in prevNode.Nodes)
						{
							if (tmpNode.Text != "Searching..." && tmpNode.Tag.ToString().ToUpper() == ((TreeNode)newNodes[i]).Tag.ToString().ToUpper())
							{
								NodeExists = true;
								break;
							}
						}
					}
					if (!NodeExists)
						prevNode.Nodes.Add((TreeNode)newNodes[i]);
				}
			}
			if (tmpRMNode != null)
				tmpRMNode.Remove();
			
			this.trvExplorer.EndUpdate();
			
			SortIt(prevNode);
			
			//this.trvExplorer.SelectedNode.EnsureVisible();
			
			//My_StillShowProgress -= 1;
			//			if (My_StillShowProgress <= 0 && StopProgress != null)
			//			{
			//My_StillShowProgress = 0;
			//StopProgress();
			//			}
			
		}
		internal void AddListView(ArrayList addFolders, ArrayList addFiles) 
		{ 
			
			this.lsvExplorer.BeginUpdate();
			
			float totalSize = 0;

			ManualResetEvent tmpMRE = new ManualResetEvent(false);
			
			ArrayList tmpArray = new ArrayList();
			ArrayList newFolders = new ArrayList();
			ArrayList newFiles = new ArrayList();

            foreach (PropellentNet.FindFiles.WIN32_FIND_DATA tmpNode in addFolders)
				tmpArray.Add(tmpNode.cFileName);
			
			tmpArray.Sort();
			foreach(string tmpText in tmpArray)
			{
                foreach (PropellentNet.FindFiles.WIN32_FIND_DATA tmpNode in addFolders)
				{
					if (tmpNode.cFileName == tmpText && tmpNode.cFileName.ToLower().IndexOf("_ntfrs_") < 0)
					{
						newFolders.Add(tmpNode);
						break;
					}
				}
			}
			
			tmpArray.Clear();

            foreach (PropellentNet.FindFiles.WIN32_FIND_DATA tmpNode in addFiles)
				tmpArray.Add(tmpNode.cFileName);
			
			tmpArray.Sort();
			
			foreach(string tmpText in tmpArray)
			{
                foreach (PropellentNet.FindFiles.WIN32_FIND_DATA tmpNode in addFiles)
				{
					if (tmpNode.cFileName == tmpText)
					{
						newFiles.Add(tmpNode);
						break;
					}
				}
			}
			
			try
			{
				int iconNum = 1;
				for (int i = 0; i < newFolders.Count; i ++)
				{
					ListViewItem tmpItem = this.lsvExplorer.Items.Add(new ListViewItem(((FindFiles.WIN32_FIND_DATA)(newFolders[i])).cFileName, 0));
					tmpItem.SubItems.Add("");
					tmpItem.SubItems.Add("File Folder");
					tmpItem.SubItems.Add(dateFormat(((FindFiles.WIN32_FIND_DATA)newFolders[i]).ftLastWriteTime));
					tmpItem.SubItems.Add(dateFormat(((FindFiles.WIN32_FIND_DATA)newFolders[i]).ftCreationTime));
				}
				for (int i = 0; i < newFiles.Count; i ++)
				{
				
					bool loadThumb = false;
					
					string tmpFT = "";
					string tmpDN = "";
					string containedImage = "";
					containedImage = (((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName).ToUpper().Substring((((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName).Length - 3,3);
					
					if (containedImage == "LNK" || containedImage == "EXE" )
						containedImage = currentDirectoy() + (((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName).ToUpper();
					
					if (My_ImageArray.Contains(containedImage))
					{
						
						iconNum = (int)My_ImageArray[containedImage];
						tmpFT = (string)My_FileType[containedImage];
						
						if (My_ThumbnailExts.Contains(Path.GetExtension(((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName.ToLower())))
						{
							
							string curDir = this.currentDirectoy();
							if (!curDir.EndsWith("\\"))
								curDir += "\\";
							
							if (My_ImageArray.Contains(curDir + ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName))
							{
								iconNum = (int)My_ImageArray[curDir + ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName];
								tmpFT = (string)My_FileType[curDir + ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName];
							}
							else if (this.currentView == wdViews.Thumbnail)
								loadThumb = true; //ThreadPool.QueueUserWorkItem(new WaitCallback(loadThumbNail), new object[] {containedImage, ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName, tmpMRE});
						}
						
					}
					else
					{
						if (containedImage.EndsWith(".LNK") || containedImage.EndsWith(".EXE"))
						{
							iconNum = this.containsImage("Unknown");
							ThreadPool.QueueUserWorkItem(new WaitCallback(loadExeAndLnkIcons), new object[] {containedImage, ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName, tmpMRE});
							//loadExeAndLnkIcons(new object[] {containedImage, ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName, tmpMRE});
						}
						else
						{
							
							string iconPathTmp = (containedImage.Length > 3 ? containedImage : "C:\\test." + containedImage);
							Icon tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, false);
							if (tmpIco != null)
							{
								this.imgIcons.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
								My_ImageArray.Add(containedImage, this.imgIcons.Images.Count - 1);
								My_FileType.Add(containedImage, tmpFT);
								iconNum = this.imgIcons.Images.Count - 1;
							}
							else
								iconNum = this.containsImage("Unknown");
							
							tmpIco = null;
							tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, true);
							if (tmpIco != null)
							{
								this.imgIconsLarge.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
								this.imgThumbNails.Images.Add(tmpIco);
								iconNum = this.imgIconsLarge.Images.Count - 1;
							}
							else
								iconNum = this.containsImage("Unknown");
							
							if (this.currentView == wdViews.Thumbnail && My_ThumbnailExts.Contains(Path.GetExtension(((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName.ToLower())))
								loadThumb = true; //ThreadPool.QueueUserWorkItem(new WaitCallback(loadThumbNail), new object[] {containedImage, ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName, tmpMRE});
							
						}
						
					}
					
					string fullSize = "";
					int TmpSize = (int)((FindFiles.WIN32_FIND_DATA)(newFiles[i])).nFileSizeLow;
					totalSize += TmpSize;
					
					if (TmpSize > 999 && TmpSize < 1000000000)
					{
						TmpSize = TmpSize / 1000;
						if (TmpSize > 1000)
							fullSize = TmpSize.ToString("0,000") + " KB";
						else
						{
							fullSize = TmpSize.ToString("0") + " KB";
						}
					}
					else if(TmpSize > 1000000000)
					{
						TmpSize = TmpSize / 1000;
						fullSize = TmpSize.ToString("0,000,000") + " KB";
					}
					else if(TmpSize > 1)
						fullSize = "1 KB";
					else
						fullSize = "0 KB";
					
					string fileText = ((FindFiles.WIN32_FIND_DATA)(newFiles[i])).cFileName;
					
					ListViewItem tmpItem = this.lsvExplorer.Items.Add(new ListViewItem(fileText, iconNum));  
					tmpItem.SubItems.Add(fullSize);
					tmpItem.SubItems.Add(tmpFT);
					tmpItem.SubItems.Add(dateFormat(((FindFiles.WIN32_FIND_DATA)newFiles[i]).ftLastWriteTime));
					tmpItem.SubItems.Add(dateFormat(((FindFiles.WIN32_FIND_DATA)newFiles[i]).ftCreationTime));
					
					if (loadThumb)
						ThreadPool.QueueUserWorkItem(new WaitCallback(loadThumbNail), new object[] {containedImage, tmpItem, tmpMRE});
					
				}
			}
			catch (Exception la)
			{
				Trace.WriteLine(la.Message + "\r\n" + la.StackTrace);
			}
			
			try
			{
				string totSize = "0 bytes";
				
				if(totalSize < 1000)
					totSize = totalSize + " Bytes";
				else if(totalSize < 1000000)
					totSize = ((String)(totalSize / 1000).ToString()).Substring(0,(totalSize / 1000).ToString().IndexOf(".") + 3) + " KB";
				else if(totalSize < 1000000000)
					totSize = ((String)(totalSize / 1000000).ToString()).Substring(0,(totalSize / 1000000).ToString().IndexOf(".") + 3) + " MB";
				else
					totSize = ((String)(totalSize / 1000000000).ToString()).Substring(0,(totalSize / 1000000000).ToString().IndexOf(".") + 3)  + " GB";
				
				if (StatusChanged != null)
					StatusChanged((this.lsvExplorer.Items.Count > 999 ? this.lsvExplorer.Items.Count.ToString("0,000") + " objects" : this.lsvExplorer.Items.Count.ToString() + " objects"), totSize, this.trvExplorer.SelectedNode.Text);
			}
			catch{}
			
			this.lsvExplorer.EndUpdate();
			
			My_StillShowProgress -= 1;
			if (My_StillShowProgress <= 0 && StopProgress != null)
			{
				My_StillShowProgress = 0;
				StopProgress();
			}
			
			tmpMRE.Set();
			
			return;
			
		}
		
		internal void AddListViewRL(ArrayList newFolders, ArrayList newFiles) 
		{ 
			
			try
			{
				int iconNum = 1;
				for (int i = 0; i < newFolders.Count; i ++)
				{
					this.lsvExplorer.Items.Add(new ListViewItem((string)newFolders[i], 0));
				}
				for (int i = 0; i < newFiles.Count; i ++)
				{
					if (My_ImageArray.Contains(((string)newFiles[i]).ToUpper().Substring(((string)newFiles[i]).Length - 3,3)))
					{
						iconNum = (int)My_ImageArray[((string)newFiles[i]).ToUpper().Substring(((string)newFiles[i]).Length - 3,3)];
					}
					else
					{
						string tmpFT = "";
						string tmpDN = "";
						
						this.imgIconsLarge.Images.Add(wdExtractIcon.GetIcon("c:\\test." + ((string)newFiles[i]).ToUpper().Substring(((string)newFiles[i]).Length - 3, 3), out tmpFT, out tmpDN, true));
						this.imgThumbNails.Images.Add(wdExtractIcon.GetIcon("c:\\test." + ((string)newFiles[i]).ToUpper().Substring(((string)newFiles[i]).Length - 3, 3), out tmpFT, out tmpDN, true));
						this.imgIcons.Images.Add(wdExtractIcon.GetIcon("c:\\test." + ((string)newFiles[i]).ToUpper().Substring(((string)newFiles[i]).Length - 3, 3), out tmpFT, out tmpDN, false));
						My_ImageArray.Add(((string)newFiles[i]).ToUpper().Substring(((string)newFiles[i]).Length - 3, 3), this.imgIcons.Images.Count - 1);
						My_FileType.Add(((string)newFiles[i]).ToUpper().Substring(((string)newFiles[i]).Length - 3, 3), tmpFT);
						iconNum = this.imgIcons.Images.Count - 1;
					}
					
					this.lsvExplorer.Items.Add(new ListViewItem((string)newFiles[i], iconNum));
				}
			}
			catch (Exception la)
			{
				Trace.WriteLine(la.Message);
			}
			finally
			{
			}
			
			My_StillShowProgress -= 1;
			if (My_StillShowProgress <= 0 && StopProgress != null)
			{
				My_StillShowProgress = 0;
				StopProgress();
			}
			
			return;
			
		}

		private string getUNCPath(string filePath)
		{
            //Scripting.FileSystemObjectClass tmpFSO = new Scripting.FileSystemObjectClass();
            //if (filePath.StartsWith(@"\\"))
            //{
            //    return filePath;
            //}
            //else
            //{
				
            //    if (tmpFSO.Drives[filePath.Substring(0, 3)].DriveType == Scripting.DriveTypeConst.Fixed)
            //    {
            //        if (filePath.ToUpper().EndsWith(".DWG"))
            //            return "FIXED DRIVE TYPE";
            //        else
            //            return filePath;
            //    }
            //    else
            //    {
            //        if (tmpFSO.FileExists(filePath))
            //            return tmpFSO.GetFile(filePath).Drive.ShareName + @"\" + filePath.Replace(filePath.Substring(0,3), "");	
            //        else if (tmpFSO.FolderExists(filePath))
            //            return tmpFSO.GetFolder(filePath).Drive.ShareName + @"\" + filePath.Replace(filePath.Substring(0,3), "");
            //        else
            //            return filePath;
            //    }
            //}
            return filePath;
		}
		
		private string dateFormat(FILETIME fromFT)
		{
			FILETIME lFT = fromFT;
			FILETIME tmpFT = new FILETIME();
			FindFiles.SYSTEMTIME tmpST = new FindFiles.SYSTEMTIME();
			FindFiles.FileTimeToLocalFileTime(ref lFT, out tmpFT);
			FindFiles.FileTimeToSystemTime(ref tmpFT, out tmpST);
			
			string newDateFormat = tmpST.Month + "/" + tmpST.Day + "/" + tmpST.Year + " ";
			if (tmpST.Hour > 12)
				newDateFormat += tmpST.Hour - 12;
			else
				newDateFormat += tmpST.Hour;
			
			newDateFormat += ":" + tmpST.Minute.ToString("00");
			//newDateFormat += ":" + tmpST.Second.ToString("00");
			
			if(tmpST.Hour > 12)
				newDateFormat += " PM";
			else
				newDateFormat += " AM";
			
			return newDateFormat;
			
		}
				
		public void InvertSelection()
		{
			foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
				tmpItem.Selected = (tmpItem.Selected == true ? false : true);
		}
		public void SelectAll()
		{
			foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
				tmpItem.Selected = true;
		}
		
		public int SelectedItemCount
		{
			get { return this.lsvExplorer.SelectedItems.Count; }
		}

		public new void Refresh()
		{
			if (this.ActiveControl == this.lsvExplorer)
			{
				
				trvExplorer_AfterSelect(this, new TreeViewEventArgs(this.trvExplorer.SelectedNode, TreeViewAction.ByMouse));
				
			}
			else
			{
			}
		}
		
				
		#region File Functions
		private void executeFile()
		{
            executeFileThread();
            //Thread tmpExec = new Thread(new ThreadStart(executeFileThread));
            //tmpExec.Name = "Execute File";
            //tmpExec.Start();
			
		}
		private void executeWith()
		{
			
			Thread tmpExec = new Thread(new ThreadStart(executeWithThread));
			tmpExec.Name = "Execute With";
			tmpExec.Start();
			
		}
		public string currentDirectoy()
		{
			
			string directory = "";
			
			TreeNode tmpNodeW = this.trvExplorer.SelectedNode;
			if (tmpNodeW.Parent == null && tmpNodeW.Tag != null)
			{
				directory = tmpNodeW.Tag.ToString();
			}
			else
			{
				while (tmpNodeW.Parent != null)
				{
					directory = (tmpNodeW.Tag != null && tmpNodeW.Tag.ToString() != "" ? tmpNodeW.Tag + "\\" + directory : directory);
					tmpNodeW = tmpNodeW.Parent;
				}
			}
			
			if (directory.StartsWith("\\\\"))
			{
				directory = directory.Substring(2,directory.Length-2);
				directory = "\\\\" + directory.Replace("\\\\","\\");
			}
			else
				directory = directory.Replace("\\\\", "\\");
			
			return directory;
			
		}
		private string directoyFromNode(TreeNode fromNode)
		{
			
			string directory = "";
				
			TreeNode tmpNodeW = fromNode;
			while (tmpNodeW.Parent != null)
			{
				directory = (tmpNodeW.Tag != null && tmpNodeW.Tag.ToString() != "" ? tmpNodeW.Tag + "\\" + directory : directory);
				tmpNodeW = tmpNodeW.Parent;
			}
			
			return directory;
			
		}
		public void rename()
		{
			if (this.ActiveControl == this.lsvExplorer)
			{
				this.lsvExplorer.SelectedItems[0].EnsureVisible();
				this.lsvExplorer.SelectedItems[0].BeginEdit();
			}
			else if (this.ActiveControl == this.trvExplorer)
			{
				this.trvExplorer.SelectedNode.EnsureVisible();
				this.trvExplorer.SelectedNode.BeginEdit();
			}
		}
		public void delete(bool allowUndo)
		{
			
			InteropSHFileOperation shfo = new InteropSHFileOperation();
			shfo.wFunc = InteropSHFileOperation.FO_Func.FO_DELETE;
			shfo.fFlags.FOF_ALLOWUNDO = allowUndo;
			
			string directory = currentDirectoy();
			
			string filesToDelete = "";
			
			if (DeleteFile != null)
			{
				
				bool allowIt = true;
				
				for (int i = this.lsvExplorer.SelectedItems.Count-1; i >= 0; i--)
				{
					allowIt = true;
					
					DeleteFile(directory + this.lsvExplorer.SelectedItems[i].Text, ref allowIt);
					
					if (allowIt)
						filesToDelete += directory + this.lsvExplorer.SelectedItems[i].Text + "\0";
				}
				
				shfo.pFrom = filesToDelete;
				shfo.Execute();
				
			}
			else
			{
				
				if (this.ActiveControl == this.lsvExplorer)
				{
					
					for (int i = this.lsvExplorer.SelectedItems.Count-1; i >= 0; i--)
						filesToDelete += directory + this.lsvExplorer.SelectedItems[i].Text + "\0";
					
					shfo.pFrom = filesToDelete;
					shfo.Execute();
					
				}
				else if (this.ActiveControl == this.trvExplorer)
				{
					
					shfo.pFrom = currentDirectoy().Substring(0,currentDirectoy().Length-1) + '\0';
					if(shfo.Execute())
						this.trvExplorer.SelectedNode.Remove();
					
				}
				
			}
						
		}
		private void delete(bool allowUndo, TreeNode folderNode)
		{
			
			InteropSHFileOperation shfo = new InteropSHFileOperation();
			shfo.wFunc = InteropSHFileOperation.FO_Func.FO_DELETE;
			shfo.fFlags.FOF_ALLOWUNDO = allowUndo;
			
			if (DeleteFile != null)
			{
				
				bool allowIt = true;
				
				for (int i = this.lsvExplorer.SelectedItems.Count-1; i >= 0; i--)
				{
					allowIt = true;
					
					DeleteFile(directoyFromNode(folderNode), ref allowIt);
					
				}
				
				shfo.pFrom = directoyFromNode(folderNode) + '\0';
				shfo.Execute();
				folderNode.Remove();
				
			}
			else
			{
				
				shfo.pFrom = directoyFromNode(folderNode) + '\0';
				shfo.Execute();
				folderNode.Remove();
				
			}
						
		}
		public void copy()
		{
			
			string directory = currentDirectoy();
			
			string[] tmpFiles = new string[this.lsvExplorer.SelectedItems.Count];
			for (int i = 0; i < this.lsvExplorer.SelectedItems.Count; i++)
				tmpFiles[i] = directory + this.lsvExplorer.SelectedItems[i].Text;
			
			IDataObject data = new DataObject(DataFormats.FileDrop, tmpFiles);
					
			MemoryStream memo = new MemoryStream(4);
			byte[] bytes = new byte[]{5, 0, 0, 0};
			memo.Write(bytes, 0, bytes.Length);
			data.SetData("Preferred DropEffect", memo);
			
			try
			{
				Clipboard.SetDataObject(data, true);
			}
			catch{}
			
		}
		public void copy(TreeNode copyNode)
		{
			
			string directory = currentDirectoy();
			
			string[] tmpFiles = new string[1];
			tmpFiles[0] = directoyFromNode(copyNode);
			tmpFiles[0] = tmpFiles[0].Substring(0,tmpFiles[0].Length-1);
			
			IDataObject data = new DataObject(DataFormats.FileDrop, tmpFiles);
			
			MemoryStream memo = new MemoryStream(4);
			byte[] bytes = new byte[]{5, 0, 0, 0};
			memo.Write(bytes, 0, bytes.Length);
			data.SetData("Preferred DropEffect", memo);
			
			try
			{
				Clipboard.SetDataObject(data, true);
			}
			catch{}
			
		}
		public void cut()
		{
			
			string directory = currentDirectoy();
			
			string[] tmpFiles = new string[this.lsvExplorer.SelectedItems.Count];
			for (int i = 0; i < this.lsvExplorer.SelectedItems.Count; i++)
				tmpFiles[i] = directory + this.lsvExplorer.SelectedItems[i].Text;
			
			IDataObject data = new DataObject(DataFormats.FileDrop, tmpFiles);
					
			MemoryStream memo = new MemoryStream(4);
			byte[] bytes = new byte[]{2, 0, 0, 0};
			memo.Write(bytes, 0, bytes.Length);
			data.SetData("Preferred DropEffect", memo);
			
			try
			{
				Clipboard.SetDataObject(data, true);
			}
			catch{}
			
		}
		private void cut(TreeNode cutNode)
		{
			
			string directory = currentDirectoy();
			
			string[] tmpFiles = new string[1];
			tmpFiles[0] = directoyFromNode(cutNode);
			tmpFiles[0] = tmpFiles[0].Substring(0,tmpFiles[0].Length-1);
			
			IDataObject data = new DataObject(DataFormats.FileDrop, tmpFiles);
			
			MemoryStream memo = new MemoryStream(4);
			byte[] bytes = new byte[]{2, 0, 0, 0};
			memo.Write(bytes, 0, bytes.Length);
			data.SetData("Preferred DropEffect", memo);
			
			try
			{
				Clipboard.SetDataObject(data, true);
			}
			catch{}
			
		}
		public void paste(string toDirectory)
		{
			
			//string directory = currentDirectoy();
			
			IDataObject data = Clipboard.GetDataObject();
			
			InteropSHFileOperation shfo = new InteropSHFileOperation();
			shfo.wFunc = InteropSHFileOperation.FO_Func.FO_DELETE;
			shfo.fFlags.FOF_ALLOWUNDO = true;
			
			if (data.GetDataPresent(DataFormats.FileDrop))
			{
				
				bool cut = false;
				
				string[] files = (string[])data.GetData(DataFormats.FileDrop);
				try
				{
					
					MemoryStream stream = (MemoryStream)data.GetData("Preferred DropEffect", true);
					int flag = stream.ReadByte();
					
					if (flag != 2 && flag != 5)
						return;
					
					cut = (flag == 2);
					
				}
				catch{}
				
				if (cut)
					shfo.wFunc = InteropSHFileOperation.FO_Func.FO_MOVE;
				else
					shfo.wFunc = InteropSHFileOperation.FO_Func.FO_COPY;
				
				string filesToPaste = "";
				string toPath = "";
				string fromPath = "";
				string fileName = "";
				
				foreach (string file in files)
				{
					
					fromPath = "";
					
					try
					{
						fromPath = file.Substring(0,file.LastIndexOf("\\")+1);;
					}
					catch{}
					
					if (fromPath == toDirectory)
					{
						string FileExt = "";
						fileName = file.Replace(fromPath,"");
						
						FileExt = Path.GetExtension(fileName);
						if (FileExt != "")
						{
							if (File.Exists(fromPath + "Copy Of " + fileName))
							{
								for (int i = 2; i < 1000; i++)
								{
									if (!File.Exists(fromPath + "Copy (" + i + ") Of " + fileName))
									{
										toPath += fromPath + "Copy (" + i + ") Of " + fileName + "\0";
										filesToPaste += fromPath + fileName + "\0";
										break;
									}
								}
							}
							else
							{
								toPath += fromPath + "Copy Of " + fileName + "\0";
								filesToPaste += fromPath + fileName + "\0";
							}
						}
						else
						{
							if (Directory.Exists(fromPath + "Copy Of " + fileName))
							{
								for (int i = 2; i < 1000; i++)
								{
									if (!Directory.Exists(fromPath + "Copy (" + i + ") Of " + fileName))
									{
										toPath += fromPath + "Copy (" + i + ") Of " + fileName + "\0";
										filesToPaste += fromPath + fileName + "\0";
										break;
									}
								}
							}
							else
							{
								toPath += fromPath + "Copy Of " + fileName + "\0";
								filesToPaste += fromPath + fileName + "\0";
							}
						}
						
					}
					else
					{
						filesToPaste += file + "\0";
						toPath += toDirectory + Path.GetFileName(file) + "\0";
					}
					
				}
				
				shfo.pFrom = filesToPaste;
				shfo.pTo = toPath;
				shfo.fFlags.FOF_MULTIDESTFILES = true;
				shfo.fFlags.FOF_NO_CONNECTED_ELEMENTS = true;
				shfo.fFlags.FOF_WANTNUKEWARNING = true;
				shfo.Execute();
			}
			
		}
		public void pasteShortcut()
		{
			
			string directory = currentDirectoy();
			
			IDataObject data = Clipboard.GetDataObject();
						
			if (data.GetDataPresent(DataFormats.FileDrop))
			{
				
				bool cut = false;
				
				string[] files = (string[])data.GetData(DataFormats.FileDrop);
				try
				{
					MemoryStream stream = (MemoryStream)data.GetData("Preferred DropEffect", true);
					int flag = stream.ReadByte();
					
					if (flag != 2 && flag != 5)
						return;
					
					cut = (flag == 2);
					
				}
				catch{}
				
				foreach (string file in files)
				{
					ShellLink tmpSL = new ShellLink();
					tmpSL.Target = file;
					tmpSL.Save(directory + "Shortcut to " + Path.GetFileName(file) + ".lnk");
				}
				
			}
			
		}
		public void createShortcut()
		{
			
			string directory = currentDirectoy();
			
			foreach(ListViewItem tmpItem in this.lsvExplorer.SelectedItems)
			{
				ShellLink tmpSL = new ShellLink();
				tmpSL.Target = directory + tmpItem.Text;
				tmpSL.Save(directory + "Shortcut to " + Path.GetFileName(tmpItem.Text) + ".lnk");
			}
			
		}
		public void undoMove()
		{
			
		}
		public bool copyToFolder(string fromFile, string toFile)
		{
			
			try
			{
				
				InteropSHFileOperation shfo = new InteropSHFileOperation();
				shfo.fFlags.FOF_ALLOWUNDO = true;
				shfo.wFunc = InteropSHFileOperation.FO_Func.FO_COPY;
				
				shfo.pFrom = fromFile;
				shfo.pTo = toFile; 
				
				return shfo.Execute();
				
			}
			catch (Exception wtf)
			{
				return false;
			}
			
		}
		public bool copyToFolder(string[] fromFiles, string toFolder)
		{
			
			try
			{
				InteropSHFileOperation shfo = new InteropSHFileOperation();
				shfo.fFlags.FOF_ALLOWUNDO = true;
				shfo.wFunc = InteropSHFileOperation.FO_Func.FO_COPY;
				
				string tmpFiles = "";
				foreach(string tmpStr in fromFiles)
					tmpFiles += tmpStr + '\0';
				
				shfo.pFrom = tmpFiles;
				shfo.pTo = toFolder + '\0';  
				return shfo.Execute();
				
			}
			catch (Exception wtf)
			{
				return false;
			}
						
		}
		public bool moveToFolder(string fromFile, string toFolder)
		{
			
			if (!Directory.Exists(toFolder))
				throw new Exception("To Folder does exist");
			
			try
			{
				
				InteropSHFileOperation shfo = new InteropSHFileOperation();
				shfo.fFlags.FOF_ALLOWUNDO = true;
				shfo.wFunc = InteropSHFileOperation.FO_Func.FO_MOVE;
				
				shfo.pFrom = fromFile;
				shfo.pTo = toFolder; 
				
				return shfo.Execute();
				
			}
			catch (Exception wtf)
			{
				return false;
			}
			
		}
		public bool moveToFolder(string[] fromFiles, string toFolder)
		{
			
			try
			{
				InteropSHFileOperation shfo = new InteropSHFileOperation();
				shfo.fFlags.FOF_ALLOWUNDO = true;
				shfo.wFunc = InteropSHFileOperation.FO_Func.FO_MOVE;
				
				string tmpFiles = "";
				foreach(string tmpStr in fromFiles)
					tmpFiles += tmpStr + '\0';
				
				shfo.pFrom = tmpFiles;
				shfo.pTo = toFolder + '\0';  
				return shfo.Execute();
				
			}
			catch (Exception wtf)
			{
				return false;
			}
						
		}
		public bool renameFileFolder(string pathName, string toFile)
		{
			
			try
			{
				InteropSHFileOperation shfo = new InteropSHFileOperation();
				shfo.fFlags.FOF_ALLOWUNDO = true;
				shfo.wFunc = InteropSHFileOperation.FO_Func.FO_RENAME;
				
				shfo.pFrom = pathName;
				shfo.pTo = toFile;  
				bool worked = shfo.Execute();
				
				return worked;
				
			}
			catch (Exception wtf)
			{
				return false;
			}
			
		}
		public void showProperties(string path)
		{
			SHELLEXECUTEINFO info = new SHELLEXECUTEINFO();
			info.cbSize = System.Runtime.InteropServices.Marshal.SizeOf(info);
			info.lpVerb = "properties";
			info.lpFile = path;
			info.nShow = 5;
			info.fMask = 12;
			ShellExecuteEx(ref info);
		}
		public void showProperties()
		{
			string curDir = currentDirectoy();
			
			if (this.ActiveControl == this.lsvExplorer)
			{
				foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
				{
					SHELLEXECUTEINFO info = new SHELLEXECUTEINFO();
					info.cbSize = System.Runtime.InteropServices.Marshal.SizeOf(info);
					info.lpVerb = "properties";
					info.lpFile = curDir + tmpItem.Text;
					info.nShow = 5;
					info.fMask = 12;
					ShellExecuteEx(ref info);
				}
			}
			else
			{
				SHELLEXECUTEINFO info = new SHELLEXECUTEINFO();
				info.cbSize = System.Runtime.InteropServices.Marshal.SizeOf(info);
				info.lpVerb = "properties";
				info.lpFile = curDir;
				info.nShow = 5;
				info.fMask = 12;
				ShellExecuteEx(ref info);
			}
		}
		public void CreateFolder()
		{

			try
			{
				string CurDir = currentDirectoy();
			
				int fldNum = 1;
				for (;fldNum < 1000 && Directory.Exists(CurDir + "New Folder " + fldNum); fldNum++)
					;
			
				Directory.CreateDirectory(CurDir + "New Folder " + fldNum);
			
				ListViewItem tmpItem = null;
				while (tmpItem == null)
				{
					Application.DoEvents();
					foreach(ListViewItem tmpItem1 in this.lsvExplorer.Items)
					{
						if (tmpItem1.Text.ToLower() == "new folder " + fldNum)
						{
							tmpItem = tmpItem1;
							break;
						}
					}
				}
			
				tmpItem.EnsureVisible();
				tmpItem.Selected = true;
				tmpItem.BeginEdit();
			}
			catch (Exception WTF)
			{
				Trace.WriteLine("CreateFolder Error: " + WTF.Message + "\r\n" + WTF.StackTrace);
			}
		}
		public void CreateTextFile()
		{
			
			try
			{
				string CurDir = currentDirectoy();
			
				int fldNum = 1;
				for (;fldNum < 1000 && File.Exists(CurDir + "New Text Document " + fldNum + ".txt"); fldNum++)
					;
			
				File.CreateText(CurDir + "New Text Document " + fldNum + ".txt").Close();
			
				ListViewItem tmpItem = null;
				while (tmpItem == null)
				{
					Application.DoEvents();
					foreach(ListViewItem tmpItem1 in this.lsvExplorer.Items)
					{
						if (tmpItem1.Text.ToLower() == "new text document " + fldNum + ".txt")
						{
							tmpItem = tmpItem1;
							break;
						}
					}
				}
			
				tmpItem.EnsureVisible();
				tmpItem.Selected = true;
				tmpItem.BeginEdit();
			}
			catch (Exception WTF)
			{
				Trace.WriteLine("CreateTextFile Error: " + WTF.Message + "\r\n" + WTF.StackTrace);
			}
		}
		public void CreateNewShortcut()
		{
			
			try
			{
				string CurDir = currentDirectoy();
			
				File.Create(CurDir + "New Shortcut.lnk").Close();
			
				foreach(ListViewItem tmpItm in this.lsvExplorer.Items)
				{
					if (tmpItm.Text.ToLower() == "new shortcut.lnk")
					{
						tmpItm.EnsureVisible();
						tmpItm.Selected = true;
					}
				}
			
				Process tmpProc = new Process();
				tmpProc.StartInfo.FileName = "rundll32.exe";
				tmpProc.StartInfo.Arguments = "AppWiz.Cpl,NewLinkHere " + CurDir + "New Shortcut.lnk";
				try
				{
					tmpProc.Start();
				}
				catch (Exception wtf)
				{
					Trace.WriteLine("CreateNewShortcut Error: " + wtf.Message);
				}
			}
			catch (Exception WTF)
			{
				Trace.WriteLine("CreatenewShortcut Error: " + WTF.Message + "\r\n" + WTF.StackTrace);
			}
			//rundll32.exe apwiz.cpl,NewLinkHere %1
		}
		#endregion File Functions
		
		#region browse functions
		public void browse(string path)
		{
			
			string newPath = path;
			
			if (newPath.IndexOf("%") == 0 && newPath.IndexOf("%", 2) > -1)
				newPath = newPath.Replace(newPath.Substring(0,newPath.IndexOf("%",2)+1), Environment.GetEnvironmentVariable((newPath.Substring(0,newPath.IndexOf("%",2)+1).Replace("%",""))));
			
			if (File.Exists(newPath))
			{
				
				bool allowIt = true;
				if (BeginExecuteFile != null)
					BeginExecuteFile(newPath, ref allowIt);
					
				if (allowIt)
				{
					Process tmpProc = new Process();
					tmpProc.StartInfo.FileName = newPath;
						
					try
					{
						tmpProc.Start();
					}
					catch (Exception wtf)
					{
						Trace.WriteLine("Browse Error: " + wtf.Message);
					}
				}
				
			}
			else
			{
				browseThread(newPath);
					//ThreadPool.QueueUserWorkItem(new WaitCallback(browseThread), newPath);
			}
			
		}
		#endregion browse functions
		
		public string CurrentAutoCADProfile()
		{
			
			string CurProfile = "";
			
			try
			{
				CurProfile = Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles").GetValue("").ToString();
			}
			catch{}
			
			if (CurProfile == "")
			{
				CurProfile = Environment.GetEnvironmentVariable("USERNAME");
				Registry.CurrentUser.CreateSubKey("Software\\Autodesk\\AutoCAD\\R16.1\\ACAD-301:409\\Profiles").SetValue("", CurProfile);
			}
			
			return CurProfile;
			
		}
		
		private void SetItemImageIndex(ListViewItem iToSet)
		{
			
			string curDir = this.currentDirectoy();
			if (!curDir.EndsWith("\\"))
				curDir += "\\";
			
			iToSet.ImageIndex = this.containsImage(curDir + iToSet.Text);
			
		}
		private void AddImageIcon(Image fileIcon, ImageList imageTo)
		{
			
			while (My_AddingImage)
				Thread.Sleep(100);
			
			My_AddingImage = true;
			imageTo.Images.Add(fileIcon);
			My_AddingImage = false;
			
		}
		private bool ThumbnailCallback()
		{
			return false;
		}

		
		#region TreeView Sort
		public void SortIt(TreeNode tmpNode) 
		{ 
			TreeNodeUtilities.SortNodes(tmpNode,false);
		}		
		#endregion TreeView Sort
		
		#endregion Functions
		
		#region Threads
		private void watchFolderThread()
		{
			try
			{
				fswCurrentDirectory.Path = currentDirectoy();
			}
			catch{}
		}
		private void executeFileThread()
		{
			
			string directory = currentDirectoy();
			string dirToBrowse = "";
			for(int i = 0; i < this.lsvExplorer.SelectedItems.Count; i++)
			{
				if (this.lsvExplorer.SelectedItems[i].ImageIndex != this.containsImage("Folder"))
				{
					
					bool allowIt = true;
					if (BeginExecuteFile != null)
						BeginExecuteFile(directory + this.lsvExplorer.SelectedItems[i].Text, ref allowIt);
					
					if (allowIt)
					{
						Process tmpProc = new Process();
						if (this.lsvExplorer.SelectedItems[i].Text.ToUpper().EndsWith(".LNK"))
						{
							ShellLink tmpSL = new ShellLink(directory + this.lsvExplorer.SelectedItems[i].Text);
							tmpProc.StartInfo.FileName = tmpSL.Target;
						}
						else
							tmpProc.StartInfo.FileName = directory + this.lsvExplorer.SelectedItems[i].Text;
						
						try
						{
							tmpProc.Start();
						}
						catch (Exception wtf)
						{
							Trace.WriteLine("ExecuteFileThread Error: " + wtf.Message);
						}
					}
				}
				else
				{
					if (dirToBrowse == "")
						dirToBrowse = directory + this.lsvExplorer.SelectedItems[i].Text;
				}
			}
			
			if (dirToBrowse != "")
			{
				exBrowse tmpB = new exBrowse(browse);
				this.Invoke(tmpB, new object[]{dirToBrowse});
			}
			
		}
		private void executeWithThread()
		{
			
			string directory = currentDirectoy();
			
			for(int i = 0; i < this.lsvExplorer.SelectedItems.Count; i++)
			{
				if (this.lsvExplorer.SelectedItems[i].ImageIndex != this.containsImage("Folder"))
				{
					
					bool allowIt = true;
					if (BeginExecuteFile != null)
						BeginExecuteFile(directory + this.lsvExplorer.SelectedItems[i].Text, ref allowIt);
					
					if (allowIt)
					{
						
						Process tmpProc = new Process();
						tmpProc.StartInfo.FileName = "rundll32.exe"; 
						tmpProc.StartInfo.Arguments = "shell32.dll,OpenAs_RunDLL " + directory + this.lsvExplorer.SelectedItems[i].Text;
						
						try
						{
							tmpProc.Start();
						}
						catch (Exception wtf)
						{
							Trace.WriteLine("ExecuteWithThread Error: " + wtf.Message);
						}
					}
					
				}
			}
			
		}
		private void browseThread(object Path)
		{
						
			string My_FolderPath = Path.ToString();
			
			if (!Directory.Exists(My_FolderPath))
				return;		
			
			if (!My_FolderPath.EndsWith("\\"))
				My_FolderPath += "\\";
			
			string serverShare = "";
			string restOfDir = "";
			
			TreeNode tmpNode = null;
			
			if (My_FolderPath.StartsWith(@"\\"))
			{
				
				if (My_FolderPath.EndsWith("\\") && My_FolderPath.Split(new char[] {'\\'}).Length > 5)
					My_FolderPath = My_FolderPath.Substring(0,My_FolderPath.Length-1);
				else if(My_FolderPath.Split(new char[] {'\\'}).Length < 5 && !My_FolderPath.EndsWith("\\"))
					My_FolderPath = My_FolderPath + "\\";
				
				serverShare = My_FolderPath.Substring(0, My_FolderPath.IndexOf(@"\", My_FolderPath.IndexOf(@"\",2)+2)+1);
				restOfDir = My_FolderPath.Replace(serverShare,"");
				
				My_NetworkPlaces.Expand();
								
				TreeNode [] tmpTreeChild = new TreeNode [1];
				
				if (!My_UncPaths.Contains(serverShare.ToUpper()))
				{
					string PathName = serverShare.Split(new char[]{'\\'})[3] + " on " + serverShare.Split(new char[]{'\\'})[2];
					
					Directory.CreateDirectory(Environment.GetEnvironmentVariable("USERPROFILE") + "\\NetHood\\" + PathName);
					
					tmpTreeChild[0] = new TreeNode("Searching...", 1, 1);
					tmpNode = new TreeNode(PathName, this.containsImage("Folder"), this.containsImage("Folder"), tmpTreeChild);
					tmpNode.Tag = serverShare;
					this.Invoke(new AddSingleTreeNodeDelegate(this.AddSingleTreeNode), new object[2]{tmpNode, My_NetworkPlaces}); 
					
					My_UncPaths.Add(serverShare.ToUpper(), tmpNode);
					
				}
				
				tmpNode = (TreeNode)My_UncPaths[serverShare.ToUpper()];
				
			}
			else
			{
			
				if (My_FolderPath.EndsWith("\\") && My_FolderPath.Length > 3)
					My_FolderPath = My_FolderPath.Substring(0,My_FolderPath.Length-1);
				
				serverShare = My_FolderPath.Replace(@"\\", @"\").Substring(0, 3);
				restOfDir = My_FolderPath.Replace(serverShare,"");
				
				if (My_MappedDrives.Contains(serverShare.ToUpper()))
				{
					tmpNode = (TreeNode)My_MappedDrives[serverShare.ToUpper()];
				}
				else
					return;
				
				//My_Computer.Expand();
				
			}
			
			ArrayList nodesToExpand = new ArrayList();
			if (restOfDir != "")
			{
				
				bool removedIt = false;
				if (tmpNode.Nodes.Count > 0 && tmpNode.Nodes[0].Text == "Searching...")
				{
					tmpNode.Nodes[0].Remove();
					removedIt = true;
				}
				
				foreach (string subDir in restOfDir.Split(new char[] {'\\'}))
				{
						
					if (tmpNode.Nodes.Count > 0 && tmpNode.Nodes[0].Text == "Searching...")
						tmpNode.Nodes[0].Remove();
						
					bool nodeExits = false;
					if (tmpNode.Nodes.Count > 0)
					{
						for (int i = 0; i < tmpNode.Nodes.Count; i++)
						{
							if (tmpNode.Nodes[i].Tag != null && tmpNode.Nodes[i].Tag.ToString().ToUpper() == subDir.ToUpper())
							{
								tmpNode = tmpNode.Nodes[i];
								nodeExits = true;
								break;
							}
						}
					}
						
					if (!nodeExits)
					{
						TreeNode tmpFld = new TreeNode(subDir, this.containsImage("Folder"), this.containsImage("Folder"));
						tmpFld.Tag = subDir;
							
						this.Invoke(new AddSingleTreeNodeDelegate(this.AddSingleTreeNode), new object[2]{tmpFld, tmpNode}); 
						
						nodesToExpand.Add(tmpNode);
						
						tmpNode = tmpFld;
					}
					
				}
				
				if (tmpNode.Nodes.Count == 0 || removedIt)
					this.Invoke(new AddSingleTreeNodeDelegate(this.AddSingleTreeNode), new object[2]{new TreeNode("Searching..."), tmpNode}); 
				
			}
			else
			{
				tmpNode.Expand();
			}
				
			this.trvExplorer.SelectedNode = tmpNode;
				
			Application.DoEvents();
					
			foreach(TreeNode tmpNodeE in nodesToExpand)
			{
				FindFiles tmpFind = new FindFiles(tmpNodeE);
				tmpFind.expandNode();
			}
			
			My_StillShowProgress -= 1;
			if (My_StillShowProgress <= 0 && StopProgress != null)
			{
				My_StillShowProgress = 0;
				StopProgress();
			}
			
		}
		private void loadExeAndLnkIcons(object pathANDindex)
		{
			
			ManualResetEvent mreRunWithIt = (ManualResetEvent)((object[])pathANDindex)[2];
			
			mreRunWithIt.WaitOne();
			
			string tmpFT, tmpDN;
			int iconNum = 0;
			string listItemText = ((object[])pathANDindex)[1].ToString();
			string containedImage = ((object[])pathANDindex)[0].ToString();
			string iconPathTmp = (containedImage.Length > 3 ? containedImage : "C:\\test." + containedImage);
			
			return;
			
			Icon tmpIco = null;
			
			try
			{
				tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, false);
				if (tmpIco != null)
				{
					this.imgIcons.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
					My_ImageArray.Add(containedImage, this.imgIcons.Images.Count - 1);
					My_FileType.Add(containedImage, tmpFT);
					iconNum = this.imgIcons.Images.Count - 1;
				}
				else
					iconNum = this.containsImage("Unknown");
			}
			catch
			{}
			
			try
			{
				tmpIco = null;
				tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, true);
				if (tmpIco != null)
				{
					this.imgIconsLarge.Images.Add(tmpIco); // ExtractIcon.GetIcon("C:\\Swap", true));
					this.imgThumbNails.Images.Add(tmpIco);
					iconNum = this.imgIconsLarge.Images.Count - 1;
				}
				else
					iconNum = this.containsImage("Unknown");
			}
			catch{}
			
			try
			{
				foreach(ListViewItem tmpItem in this.lsvExplorer.Items)
				{
					if (tmpItem.Text == listItemText)
					{
						exSetItemImageIndex tmpSIII = new exSetItemImageIndex(SetItemImageIndex);
						this.Invoke(tmpSIII, new object[] {tmpItem.Index, iconNum});
					}
				}
			}
			catch (Exception WTF)
			{
				Trace.WriteLine(WTF.Message);
			}
			
		}
		private void loadThumbNail(object pathANDindex)
		{
			
			ManualResetEvent mreRunWithIt = (ManualResetEvent)((object[])pathANDindex)[2];
			mreRunWithIt.WaitOne();
			
			exAddImageIcon tmpAII = new exAddImageIcon(AddImageIcon);
			
			string tmpFT, tmpDN;
			int iconNum = 0;
			ListViewItem tmpLVItem = (ListViewItem)((object[])pathANDindex)[1];
			string listItemText = tmpLVItem.Text;
			string containedImage = ((object[])pathANDindex)[0].ToString();
			string iconPathTmp = (containedImage.Length > 3 ? containedImage : "C:\\test." + containedImage);
			
			string curDir = this.currentDirectoy();
			if (!curDir.EndsWith("\\"))
				curDir += "\\";
			
			Icon tmpIco = null; 
			
			if (Path.GetExtension(listItemText.ToLower()) == ".dwg")
			{
				
				iconNum = this.imgIcons.Images.Count;
				this.Invoke(tmpAII, new object[] {this.imgIcons.Images[this.containsImage(containedImage)],imgIcons});
				My_ImageArray.Add(curDir + listItemText, this.imgIcons.Images.Count - 1);
				My_FileType.Add(curDir + listItemText, My_FileType[containedImage]);
				
                //wdDwgPreview.DrawingPreview tmpPV = new wdDwgPreview.DrawingPreview(curDir + listItemText);
                //if (tmpPV.loadPreview())
                //{
					
                //    Image tmpScaled = new Bitmap(120,120);
                //    Graphics tmpG = Graphics.FromImage(tmpScaled);
					
                //    float HeightRatio = 0.0f;
                //    float WidthRatio = 0.0f;
                //    float DrawWidth = 0.0f;
                //    float DrawHeight = 0.0f;
					
                //    HeightRatio = (float)tmpScaled.Width / (float)tmpPV.dwgPreview.Height;
                //    WidthRatio = (float)tmpScaled.Height / (float)tmpPV.dwgPreview.Width;
					
                //    if (HeightRatio < WidthRatio)
                //    {
                //        DrawHeight = tmpScaled.Height ;
                //        DrawWidth = ((float)64)*WidthRatio;
                //    }
                //    else
                //    {
                //        DrawHeight = ((float)64)*HeightRatio;
                //        DrawWidth  = tmpScaled.Width;
                //    }
					
                //    tmpG.DrawImage(tmpPV.dwgPreview, 0, 0, DrawWidth, DrawHeight);
					
                //    this.Invoke(tmpAII, new object[] {this.imgIconsLarge.Images[this.containsImage("DWG")], imgIconsLarge});
                //    this.Invoke(tmpAII, new object[] {tmpScaled, imgThumbNails});
					
                //}
                //else
                //{
					tmpIco = wdExtractIcon.GetIcon(iconPathTmp, out tmpFT, out tmpDN, true);
					if (tmpIco != null)
					{
						this.Invoke(tmpAII, new object[] {this.imgIconsLarge.Images[this.containsImage("DWG")], imgIconsLarge});
						this.Invoke(tmpAII, new object[] {(Image)tmpIco.ToBitmap(), imgThumbNails});
					}
                //}
			}
			else
			{
				try
				{
					
					this.Invoke(tmpAII, new object[] {this.imgIconsLarge.Images[this.containsImage(listItemText.ToUpper().Substring(listItemText.Length-3,3))], imgIconsLarge});
					Image tmpImg = Bitmap.FromFile(curDir + listItemText);
					
					Image.GetThumbnailImageAbort myCallback = new Image.GetThumbnailImageAbort(ThumbnailCallback);
					Image tmpImg2 = tmpImg.GetThumbnailImage(120, 120, myCallback, IntPtr.Zero);
					
					iconNum = this.imgIcons.Images.Count;
					this.Invoke(tmpAII, new object[] {this.imgIcons.Images[this.containsImage(containedImage)],imgIcons});
					My_ImageArray.Add(curDir + listItemText, this.imgIcons.Images.Count - 1);
					My_FileType.Add(curDir + listItemText, My_FileType[containedImage]);
					
					this.Invoke(tmpAII, new object[] {tmpImg2, imgThumbNails});
					tmpImg.Dispose();
					System.GC.Collect();
					
				}
				catch{}
			}
			
			exSetItemImageIndex tmpSIII = new exSetItemImageIndex(SetItemImageIndex);
			this.Invoke(tmpSIII, new object[] {tmpLVItem});
			
		}
		#endregion Threads
		
	}
	
	#region Helper Classes
	
	#region TreeViewCompair
	
	public class TreeNodeUtilities
	{
		[DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true)]
		private static extern int SendMessage(
			IntPtr hWnd, 
			int msg, 
			IntPtr wParam,
			IntPtr lParam);

		private delegate void SortNodesDelegate(TreeNode treeNode, bool recurse);

		private const int TV_FIRST = 0x1100 ;
		private const int TVM_GETNEXTITEM               = (TV_FIRST + 10);
		private const int TVM_GETITEM                   = (TV_FIRST + 62);
		private const int TVM_SORTCHILDRENCB    = (TV_FIRST + 21);
		private const int TVM_SETITEM                   = (TV_FIRST + 63);

		//TVITEM mask
		private const int TVIF_TEXT             = 0x0001;
		private const int TVIF_PARAM                    = 0x0004;

		[StructLayout(LayoutKind.Sequential)]
			private struct TVSORTCB
		{
			public IntPtr hParent ;
			[MarshalAs (UnmanagedType.FunctionPtr)]
			public exCompareNodes lpfnCompare ;
			public int lParam ;
		}

		[StructLayout(LayoutKind.Sequential)]
			private struct TVITEM 
		{
			public int mask;
			public IntPtr hItem;
			public int state;
			public int stateMask;
			[MarshalAs (UnmanagedType.LPStr)]
			public string pszText;
			public int cchTextMax;
			public int iImage;
			public int iSelectedImage;
			public int cChildren;
			public IntPtr lParam;
		}
		public static void SortNodes(TreeNode rootNode, bool recurse)
		{
			TreeNodeComparer treeNodeComparer = new TreeNodeComparer();
			SortNodes(rootNode, recurse, treeNodeComparer);
		}
		
		public static void SortNodes(TreeNode rootNode, bool recurse, TreeNodeComparer comparer)
		{
			if (rootNode.Nodes.Count == 0)
				return;
			
			if (rootNode.TreeView == null || rootNode.TreeView.IsDisposed)
				return;
			
			else if (rootNode.TreeView.InvokeRequired)
			{
				SortNodesDelegate sortNodesDelegate = new SortNodesDelegate(SortNodes);
				
				rootNode.TreeView.Invoke(sortNodesDelegate, new object[] {rootNode, recurse});
				return;
			}
			
			IntPtr rootNodeTreeViewHandle = rootNode.TreeView.Handle;
			
			foreach (TreeNode node in rootNode.Nodes)
				GenerateTVItemlParam(rootNodeTreeViewHandle, node.Handle);
			
			TVSORTCB sorter;
			
			int lparam = GetTVItemlParam(rootNodeTreeViewHandle, rootNode.Handle);
			
			sorter.hParent = rootNode.Handle;
			sorter.lpfnCompare = comparer.Comparer;
			sorter.lParam = rootNodeTreeViewHandle.ToInt32();
			
			IntPtr pSorter = Marshal.AllocHGlobal(System.Runtime.InteropServices.Marshal.SizeOf(sorter));
			Marshal.StructureToPtr(sorter, pSorter, false);
			
			int lResult = SendMessage(
				rootNode.TreeView.Handle,
				TVM_SORTCHILDRENCB, 
				IntPtr.Zero,
				pSorter);  
			
			Marshal.FreeHGlobal(pSorter);
			
			if (recurse)
			{
				foreach (TreeNode node in rootNode.Nodes)
				{
					SortNodes(node, recurse);
				}
			}
		}
		private static int GetTVItemlParam(IntPtr hwndTV, IntPtr hItem)
		{
			TVITEM tvi = new TVITEM();
			
			tvi.hItem = hItem;
			tvi.mask = TVIF_PARAM;
			
			IntPtr pItem = Marshal.AllocHGlobal(Marshal.SizeOf(tvi));
			
			Marshal.StructureToPtr(tvi, pItem, false);
            
			SendMessage(hwndTV, TVM_GETITEM, IntPtr.Zero, pItem);
			
			int lParam = tvi.lParam.ToInt32();
			
			Marshal.FreeHGlobal(pItem);
			
			return lParam;
		}
		public static TreeNode GetTVItem(IntPtr hwndTV, IntPtr hItem)
		{
			TreeView treeView = (TreeView)TreeView.FromHandle(hwndTV);
			TreeNode node = TreeNode.FromHandle(treeView, hItem);
			return node;
		}
		public static string GetTVItemText(IntPtr hwndTV, IntPtr hItem)
		{
			TreeNode node = GetTVItem(hwndTV, hItem);
			return node.Text;
		}
		private static void GenerateTVItemlParam(IntPtr hwndTV, IntPtr hItem)
		{
			TVITEM tvi = new TVITEM();
			
			tvi.hItem = hItem;
			tvi.mask = TVIF_PARAM;
			tvi.lParam = hItem;
			
			IntPtr pItem = Marshal.AllocHGlobal(Marshal.SizeOf(tvi));
			
			Marshal.StructureToPtr(tvi, pItem, false);
                	
			int result = SendMessage(hwndTV, TVM_SETITEM, IntPtr.Zero, pItem);
			
			Marshal.FreeHGlobal(pItem);
			
			return;
		}
		
		public class TreeNodeComparer
		{
			private exCompareNodes _Comparer;
		
			public exCompareNodes Comparer
			{
				get {return _Comparer;}
			}
		
			public TreeNodeComparer()
			{
				this._Comparer = new exCompareNodes(this.CompareNodes);
			}
		
			private int CompareNodes(IntPtr lParam1, IntPtr lParam2, IntPtr lParamSort)
			{
				if (lParam1 == IntPtr.Zero || lParam2 ==IntPtr.Zero)
					return 0;
			
				IntPtr hwndTV = lParamSort;
			
				TreeNode treeNode1 = TreeNodeUtilities.GetTVItem(lParamSort, lParam1);
				TreeNode treeNode2 = TreeNodeUtilities.GetTVItem(lParamSort, lParam2);
			
				return CompareNodes(treeNode1, treeNode2);
			
			}
		
			protected virtual int CompareNodes(TreeNode treeNode1, TreeNode treeNode2)
			{
				IComparable icomparable = treeNode1 as IComparable;
			
				if (icomparable == null)
				{
					return String.Compare(treeNode1.Text, treeNode2.Text);
				}
				else
				{
					return icomparable.CompareTo(treeNode2);
				}
			}
		}
	}
	#endregion
	
	#region ListViewColumnSorter
	public class ListViewColumnSorter : IComparer
	{
		
		private int ColumnToSort;
		private System.Windows.Forms.SortOrder OrderOfSort;
		private CaseInsensitiveComparer ObjectCompare;
		public ListViewColumnSorter()
		{
			// Initialize the column to '0'
			ColumnToSort = 0;
			
			// Initialize the sort order to 'none'
			OrderOfSort = System.Windows.Forms.SortOrder.None;
			
			// Initialize the CaseInsensitiveComparer object
			ObjectCompare = new CaseInsensitiveComparer();
		}
		
		public int Compare(object x, object y)
		{
			
			try
			{
				int compareResult = 0;
				ListViewItem listviewX, listviewY;
				
				listviewX = (ListViewItem)x;
				listviewY = (ListViewItem)y;
				
				if (ColumnToSort == 1)
				{
					if (listviewX.ImageIndex == 0)
						compareResult = ObjectCompare.Compare(listviewX.SubItems[ColumnToSort].Text,listviewY.SubItems[ColumnToSort].Text);
					else
					{
						int lvSizeX = int.Parse(listviewX.SubItems[ColumnToSort].Text.Replace(" KB", "").Replace(",",""));
						int lvSizeY = int.Parse(listviewY.SubItems[ColumnToSort].Text.Replace(" KB", "").Replace(",",""));
						if (lvSizeX > lvSizeY)
							compareResult = 1;
						else
							compareResult = -1;
					}
				}
				else if(ColumnToSort == 3 || ColumnToSort == 3)
				{
					DateTime lvDtX = DateTime.Parse(listviewX.SubItems[ColumnToSort].Text);
					DateTime lvDtY = DateTime.Parse(listviewY.SubItems[ColumnToSort].Text);
					
					if (lvDtX > lvDtY)
						compareResult = 1;
					else
						compareResult = -1;
				}
				else
					compareResult = ObjectCompare.Compare(listviewX.SubItems[ColumnToSort].Text,listviewY.SubItems[ColumnToSort].Text);
				
				if (OrderOfSort == System.Windows.Forms.SortOrder.Ascending)
				{
					if (listviewX.ImageIndex == 0 && listviewY.ImageIndex != 0)
						compareResult = -1;
					return compareResult;
				}
				else if (OrderOfSort == System.Windows.Forms.SortOrder.Descending)
				{
					if (listviewX.ImageIndex == 0 && listviewY.ImageIndex != 0)
						compareResult = 1;
					return (-compareResult);
				}
				else
				{
					return 0;
				}
			}
			catch (Exception WTF)
			{
				Trace.WriteLine("Compare ListView: " + WTF.Message + "\r\n" + WTF.StackTrace);
				return 0;
			}
		}
		
		/// <summary>
		/// Gets or sets the number of the column to which to apply the sorting operation (Defaults to '0').
		/// </summary>
		public int SortColumn
		{
			set
			{
				ColumnToSort = value;
			}
			get
			{
				return ColumnToSort;
			}
		}

		/// <summary>
		/// Gets or sets the order of sorting to apply (for example, 'Ascending' or 'Descending').
		/// </summary>
		public System.Windows.Forms.SortOrder Order
		{
			set
			{
				OrderOfSort = value;
			}
			get
			{
				return OrderOfSort;
			}
		}
    
	}
	#endregion ListViewColumnSorter
	
	#region ShellLink
	public class ShellLink : IDisposable
	{
		#region ComInterop for IShellLink

		#region IPersist Interface
		[ComImportAttribute()]
			[GuidAttribute("0000010C-0000-0000-C000-000000000046")]
			[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
			private interface IPersist
		{
			[PreserveSig]
				//[helpstring("Returns the class identifier for the component			object")]
			void GetClassID(out Guid pClassID);
		}
		#endregion

		#region IPersistFile Interface
		[ComImportAttribute()]
			[GuidAttribute("0000010B-0000-0000-C000-000000000046")]
			[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
			private interface IPersistFile
		{
			// can't get this to go if I extend IPersist, so put it here:
			[PreserveSig]
			void GetClassID(out Guid pClassID);

			//[helpstring("Checks for changes since last file write")]      
			void IsDirty();

			//[helpstring("Opens the specified file and initializes the object			from its contents")]      
			void Load(
				[MarshalAs(UnmanagedType.LPWStr)] string pszFileName, 
				uint dwMode);

			//[helpstring("Saves the object into the specified file")]      
			void Save(
				[MarshalAs(UnmanagedType.LPWStr)] string pszFileName, 
				[MarshalAs(UnmanagedType.Bool)] bool fRemember);

			//[helpstring("Notifies the object that save is completed")]      
			void SaveCompleted(
				[MarshalAs(UnmanagedType.LPWStr)] string pszFileName);

			//[helpstring("Gets the current name of the file associated with the			object")]      
			void GetCurFile(
				[MarshalAs(UnmanagedType.LPWStr)] out string ppszFileName);
		}
		#endregion

		#region IShellLink Interface
		[ComImportAttribute()]
			[GuidAttribute("000214EE-0000-0000-C000-000000000046")]
			[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
			private interface IShellLinkA
		{
			//[helpstring("Retrieves the path and filename of a shell link			object")]
			void GetPath(
				[Out(), MarshalAs(UnmanagedType.LPStr)] StringBuilder pszFile, 
				int cchMaxPath, 
				ref _WIN32_FIND_DATAA pfd, 
				uint fFlags);

			//[helpstring("Retrieves the list of shell link item identifiers")]
			void GetIDList(out IntPtr ppidl);

			//[helpstring("Sets the list of shell link item identifiers")]
			void SetIDList(IntPtr pidl);

			//[helpstring("Retrieves the shell link description string")]
			void GetDescription(
				[Out(), MarshalAs(UnmanagedType.LPStr)] StringBuilder pszFile,
				int cchMaxName);
      
			//[helpstring("Sets the shell link description string")]
			void SetDescription(
				[MarshalAs(UnmanagedType.LPStr)] string pszName);

			//[helpstring("Retrieves the name of the shell link working			directory")]
			void GetWorkingDirectory(
				[Out(), MarshalAs(UnmanagedType.LPStr)] StringBuilder pszDir,
				int cchMaxPath);

			//[helpstring("Sets the name of the shell link working directory")]
			void SetWorkingDirectory(
				[MarshalAs(UnmanagedType.LPStr)] string pszDir);

			//[helpstring("Retrieves the shell link command-line arguments")]
			void GetArguments(
				[Out(), MarshalAs(UnmanagedType.LPStr)] StringBuilder pszArgs, 
				int cchMaxPath);

			//[helpstring("Sets the shell link command-line arguments")]
			void SetArguments(
				[MarshalAs(UnmanagedType.LPStr)] string pszArgs);

			//[propget, helpstring("Retrieves or sets the shell link hot key")]
			void GetHotkey(out short pwHotkey);
			//[propput, helpstring("Retrieves or sets the shell link hot key")]
			void SetHotkey(short pwHotkey);

			//[propget, helpstring("Retrieves or sets the shell link show			command")]
			void GetShowCmd(out uint piShowCmd);
			//[propput, helpstring("Retrieves or sets the shell link show			command")]
			void SetShowCmd(uint piShowCmd);

			//[helpstring("Retrieves the location (path and index) of the shell			link icon")]
			void GetIconLocation(
				[Out(), MarshalAs(UnmanagedType.LPStr)] StringBuilder pszIconPath, 
				int cchIconPath, 
				out int piIcon);
      
			//[helpstring("Sets the location (path and index) of the shell link			icon")]
			void SetIconLocation(
				[MarshalAs(UnmanagedType.LPStr)] string pszIconPath, 
				int iIcon);

			//[helpstring("Sets the shell link relative path")]
			void SetRelativePath(
				[MarshalAs(UnmanagedType.LPStr)] string pszPathRel, 
				uint dwReserved);

			//[helpstring("Resolves a shell link. The system searches for the			shell link object and updates the shell link path and its list of																			   identifiers (if necessary)")]
			void Resolve(
				IntPtr hWnd, 
				uint fFlags);

			//[helpstring("Sets the shell link path and filename")]
			void SetPath(
				[MarshalAs(UnmanagedType.LPStr)] string pszFile);
		}


		[ComImportAttribute()]
			[GuidAttribute("000214F9-0000-0000-C000-000000000046")]
			[InterfaceTypeAttribute(ComInterfaceType.InterfaceIsIUnknown)]
			private interface IShellLinkW
		{
			//[helpstring("Retrieves the path and filename of a shell link			object")]
			void GetPath(
				[Out(), MarshalAs(UnmanagedType.LPWStr)] StringBuilder pszFile, 
				int cchMaxPath, 
				ref _WIN32_FIND_DATAW pfd, 
				uint fFlags);

			//[helpstring("Retrieves the list of shell link item identifiers")]
			void GetIDList(out IntPtr ppidl);

			//[helpstring("Sets the list of shell link item identifiers")]
			void SetIDList(IntPtr pidl);

			//[helpstring("Retrieves the shell link description string")]
			void GetDescription(
				[Out(), MarshalAs(UnmanagedType.LPWStr)] StringBuilder pszFile,
				int cchMaxName);
      
			//[helpstring("Sets the shell link description string")]
			void SetDescription(
				[MarshalAs(UnmanagedType.LPWStr)] string pszName);

			//[helpstring("Retrieves the name of the shell link working			directory")]
			void GetWorkingDirectory(
				[Out(), MarshalAs(UnmanagedType.LPWStr)] StringBuilder pszDir,
				int cchMaxPath);

			//[helpstring("Sets the name of the shell link working directory")]
			void SetWorkingDirectory(
				[MarshalAs(UnmanagedType.LPWStr)] string pszDir);

			//[helpstring("Retrieves the shell link command-line arguments")]
			void GetArguments(
				[Out(), MarshalAs(UnmanagedType.LPWStr)] StringBuilder pszArgs, 
				int cchMaxPath);

			//[helpstring("Sets the shell link command-line arguments")]
			void SetArguments(
				[MarshalAs(UnmanagedType.LPWStr)] string pszArgs);

			//[propget, helpstring("Retrieves or sets the shell link hot key")]
			void GetHotkey(out short pwHotkey);
			//[propput, helpstring("Retrieves or sets the shell link hot key")]
			void SetHotkey(short pwHotkey);

			//[propget, helpstring("Retrieves or sets the shell link show			command")]
			void GetShowCmd(out uint piShowCmd);
			//[propput, helpstring("Retrieves or sets the shell link show			command")]
			void SetShowCmd(uint piShowCmd);

			//[helpstring("Retrieves the location (path and index) of the shell			link icon")]
			void GetIconLocation(
				[Out(), MarshalAs(UnmanagedType.LPWStr)] StringBuilder pszIconPath, 
				int cchIconPath, 
				out int piIcon);
      
			//[helpstring("Sets the location (path and index) of the shell link			icon")]
			void SetIconLocation(
				[MarshalAs(UnmanagedType.LPWStr)] string pszIconPath, 
				int iIcon);

			//[helpstring("Sets the shell link relative path")]
			void SetRelativePath(
				[MarshalAs(UnmanagedType.LPWStr)] string pszPathRel, 
				uint dwReserved);

			//[helpstring("Resolves a shell link. The system searches for the			shell link object and updates the shell link path and its list of																			   identifiers (if necessary)")]
			void Resolve(
				IntPtr hWnd, 
				uint fFlags);

			//[helpstring("Sets the shell link path and filename")]
			void SetPath(
				[MarshalAs(UnmanagedType.LPWStr)] string pszFile);
		}
		#endregion

		#region ShellLinkCoClass
		[GuidAttribute("00021401-0000-0000-C000-000000000046")]
			[ClassInterfaceAttribute(ClassInterfaceType.None)]
			[ComImportAttribute()]
			private class CShellLink{}

		#endregion
   
		#region Private IShellLink enumerations
		private enum EShellLinkGP : uint
		{
			SLGP_SHORTPATH = 1,
			SLGP_UNCPRIORITY = 2
		}

		[Flags]
			private enum EShowWindowFlags : uint
		{
			SW_HIDE = 0,
			SW_SHOWNORMAL = 1,
			SW_NORMAL = 1,
			SW_SHOWMINIMIZED = 2,
			SW_SHOWMAXIMIZED = 3,
			SW_MAXIMIZE = 3,
			SW_SHOWNOACTIVATE = 4,
			SW_SHOW = 5,
			SW_MINIMIZE = 6,
			SW_SHOWMINNOACTIVE = 7,
			SW_SHOWNA = 8,
			SW_RESTORE = 9,
			SW_SHOWDEFAULT = 10,
			SW_MAX = 10
		}
		#endregion

		#region IShellLink Private structs

		[StructLayoutAttribute(LayoutKind.Sequential, Pack=4, Size=0,
			 CharSet=CharSet.Unicode)]
			private struct _WIN32_FIND_DATAW
		{
			public uint dwFileAttributes;
			public _FILETIME ftCreationTime;
			public _FILETIME ftLastAccessTime;
			public _FILETIME ftLastWriteTime;
			public uint nFileSizeHigh;
			public uint nFileSizeLow;
			public uint dwReserved0;
			public uint dwReserved1;
			[MarshalAs(UnmanagedType.ByValTStr , SizeConst = 260)] // MAX_PATH
			public string cFileName;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 14)]
			public string cAlternateFileName;
		}

		[StructLayoutAttribute(LayoutKind.Sequential, Pack=4, Size=0,
			 CharSet=CharSet.Ansi)]
			private struct _WIN32_FIND_DATAA
		{
			public uint dwFileAttributes;
			public _FILETIME ftCreationTime;
			public _FILETIME ftLastAccessTime;
			public _FILETIME ftLastWriteTime;
			public uint nFileSizeHigh;
			public uint nFileSizeLow;
			public uint dwReserved0;
			public uint dwReserved1;
			[MarshalAs(UnmanagedType.ByValTStr , SizeConst = 260)] // MAX_PATH
			public string cFileName;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 14)]
			public string cAlternateFileName;
		}

		[StructLayoutAttribute(LayoutKind.Sequential, Pack=4, Size=0)]
			private struct _FILETIME 
		{
			public uint dwLowDateTime;
			public uint dwHighDateTime;
		}  
		#endregion   

		#region UnManaged Methods
		private class UnManagedMethods
		{
			[DllImport("Shell32", CharSet=CharSet.Auto)]
			internal extern static int ExtractIconEx (
				[MarshalAs(UnmanagedType.LPTStr)] 
				string lpszFile,
				int nIconIndex,
				IntPtr[] phIconLarge, 
				IntPtr[] phIconSmall,
				int nIcons);

			[DllImport("user32")]
			internal static extern int DestroyIcon(IntPtr hIcon);
		}
		#endregion

		#endregion

		#region Enumerations
		/// <summary>
		/// Flags determining how the links with missing
		/// targets are resolved.
		/// </summary>
		[Flags]
			public enum EShellLinkResolveFlags : uint
		{
			/// <summary>
			/// Allow any match during resolution.  Has no effect
			/// on ME/2000 or above, use the other flags instead.
			/// </summary>
			SLR_ANY_MATCH = 0x2,
			/// <summary>
			/// Call the Microsoft Windows Installer. 
			/// </summary>
			SLR_INVOKE_MSI = 0x80,
			/// <summary>
			/// Disable distributed link tracking. By default, 
			/// distributed link tracking tracks removable media 
			/// across multiple devices based on the volume name. 
			/// It also uses the UNC path to track remote file 
			/// systems whose drive letter has changed. Setting 
			/// SLR_NOLINKINFO disables both types of tracking.
			/// </summary>
			SLR_NOLINKINFO = 0x40,
			/// <summary>
			/// Do not display a dialog box if the link cannot be resolved. 
			/// When SLR_NO_UI is set, a time-out value that specifies the 
			/// maximum amount of time to be spent resolving the link can 
			/// be specified in milliseconds. The function returns if the 
			/// link cannot be resolved within the time-out duration. 
			/// If the timeout is not set, the time-out duration will be 
			/// set to the default value of 3,000 milliseconds (3 seconds). 
			/// </summary>                                  
			SLR_NO_UI = 0x1,
			/// <summary>
			/// Not documented in SDK.  Assume same as SLR_NO_UI but 
			/// intended for applications without a hWnd.
			/// </summary>
			SLR_NO_UI_WITH_MSG_PUMP = 0x101,
			/// <summary>
			/// Do not update the link information. 
			/// </summary>
			SLR_NOUPDATE = 0x8,
			/// <summary>
			/// Do not execute the search heuristics. 
			/// </summary>                                                        
                                                                               
                                                                               
                                                                               
                                                                               
                                                                               
                                                                               
                                                                               
                                                                               
           
			SLR_NOSEARCH = 0x10,
			/// <summary>
			/// Do not use distributed link tracking. 
			/// </summary>
			SLR_NOTRACK = 0x20,
			/// <summary>
			/// If the link object has changed, update its path and list 
			/// of identifiers. If SLR_UPDATE is set, you do not need to 
			/// call IPersistFile::IsDirty to determine whether or not 
			/// the link object has changed. 
			/// </summary>
			SLR_UPDATE  = 0x4
		}

		public enum LinkDisplayMode : uint
		{
			edmNormal = EShowWindowFlags.SW_NORMAL,
			edmMinimized = EShowWindowFlags.SW_SHOWMINNOACTIVE,
			edmMaximized = EShowWindowFlags.SW_MAXIMIZE
		}
		#endregion

		#region Member Variables
		// Use Unicode (W) under NT, otherwise use ANSI      
		private IShellLinkW linkW;
		private IShellLinkA linkA;
		private string shortcutFile = "";
		#endregion

		#region Constructor
		/// <summary>
		/// Creates an instance of the Shell Link object.
		/// </summary>
		public ShellLink()
		{
			if (System.Environment.OSVersion.Platform == PlatformID.Win32NT)
			{
				linkW = (IShellLinkW)new CShellLink();
			}
			else
			{
				linkA = (IShellLinkA)new CShellLink();
			}
		}

		/// <summary>
		/// Creates an instance of a Shell Link object
		/// from the specified link file
		/// </summary>
		/// <param name="linkFile">The Shortcut file to open</param>
		public ShellLink(string linkFile) : this()
		{
			Open(linkFile);
		}
		#endregion

		#region Destructor and Dispose
		/// <summary>
		/// Call dispose just in case it hasn't happened yet
		/// </summary>
		~ShellLink()
		{
			Dispose();
		}

		/// <summary>
		/// Dispose the object, releasing the COM ShellLink object
		/// </summary>
		public void Dispose()
		{
			if (linkW != null ) 
			{
				Marshal.ReleaseComObject(linkW);
				linkW = null;
			}
			if (linkA != null)
			{
				Marshal.ReleaseComObject(linkA);
				linkA = null;
			}
		}
		#endregion

		#region Implementation
		public string ShortCutFile
		{
			get
			{
				return this.shortcutFile;
			}
			set
			{
				this.shortcutFile = value;
			}
		}

		/// <summary>
		/// Gets a System.Drawing.Icon containing the icon for this
		/// ShellLink object.
		/// </summary>
		public Icon LargeIcon
		{
			get
			{
				return getIcon(true);
			}
		}

		public Icon SmallIcon
		{
			get
			{
				return getIcon(false);
			}
		}

		private Icon getIcon(bool large)
		{
			// Get icon index and path:
			int iconIndex = 0;
			StringBuilder iconPath = new StringBuilder(260, 260);
			if (linkA == null)
			{
				linkW.GetIconLocation(iconPath, iconPath.Capacity, out iconIndex);
			}
			else
			{
				linkA.GetIconLocation(iconPath, iconPath.Capacity, out iconIndex);
			}
			string iconFile = iconPath.ToString();
			
			// If there are no details set for the icon, then we must use
			// the shell to get the icon for the target:
			if (iconFile.Length == 0)
			{
				// Use the FileIcon object to get the icon:
				
				return wdExtractIcon.GetIconShortcut(Target, large);
			}
			else
			{
				// Use ExtractIconEx to get the icon:
				IntPtr[] hIconEx = new IntPtr[1] {IntPtr.Zero};
				int iconCount = 0;
				if (large)
				{
					iconCount = UnManagedMethods.ExtractIconEx(
						iconFile,
						iconIndex,
						hIconEx,
						null,
						1);
				}
				else
				{
					iconCount = UnManagedMethods.ExtractIconEx(
						iconFile,
						iconIndex,
						null,
						hIconEx,
						1);
				}
				// If success then return as a GDI+ object
				Icon icon = null;
				if (hIconEx[0] != IntPtr.Zero)
				{
					icon = Icon.FromHandle(hIconEx[0]);
					//UnManagedMethods.DestroyIcon(hIconEx[0]);
				}
				return icon;
			} 
		}

		/// <summary>
		/// Gets the path to the file containing the icon for this shortcut.
		/// </summary>
		public string IconPath
		{
			get
			{
				StringBuilder iconPath = new StringBuilder(260, 260);
				int iconIndex = 0;
				if (linkA == null)
				{
					linkW.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				else
				{
					linkA.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				return iconPath.ToString();
			}
			set
			{
				StringBuilder iconPath = new StringBuilder(260, 260);
				int iconIndex = 0;
				if (linkA == null)
				{
					linkW.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				else
				{
					linkA.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				if (linkA == null)
				{
					linkW.SetIconLocation(value, iconIndex);
				}
				else
				{
					linkA.SetIconLocation(value, iconIndex);
				}
			}
		}

		/// <summary>
		/// Gets the index of this icon within the icon path's resources
		/// </summary>
		public int IconIndex
		{
			get
			{
				StringBuilder iconPath = new StringBuilder(260, 260);
				int iconIndex = 0;
				if (linkA == null)
				{
					linkW.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				else
				{
					linkA.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				return iconIndex;
			}
			set
			{
				StringBuilder iconPath = new StringBuilder(260, 260);
				int iconIndex = 0;
				if (linkA == null)
				{
					linkW.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				else
				{
					linkA.GetIconLocation(iconPath, iconPath.Capacity, out
						iconIndex);
				}
				if (linkA == null)
				{
					linkW.SetIconLocation(iconPath.ToString(), value);
				}
				else
				{
					linkA.SetIconLocation(iconPath.ToString(), value);
				}
			}
		}

		/// <summary>
		/// Gets/sets the fully qualified path to the link's target
		/// </summary>
		public string Target
		{
			get
			{      
				StringBuilder target = new StringBuilder(260, 260);
				if (linkA == null)
				{
					_WIN32_FIND_DATAW fd = new _WIN32_FIND_DATAW();
					linkW.GetPath(target, target.Capacity, ref fd,
						(uint)EShellLinkGP.SLGP_UNCPRIORITY);
				}
				else
				{
					_WIN32_FIND_DATAA fd = new _WIN32_FIND_DATAA();
					linkA.GetPath(target, target.Capacity, ref fd,
						(uint)EShellLinkGP.SLGP_UNCPRIORITY);
				}
				return target.ToString();
			}
			set
			{
				if (linkA == null)
				{
					linkW.SetPath(value);
				}
				else
				{
					linkA.SetPath(value);
				}
			}
		}

		/// <summary>
		/// Gets/sets the Working Directory for the Link
		/// </summary>
		public string WorkingDirectory
		{
			get
			{
				StringBuilder path = new StringBuilder(260, 260);
				if (linkA == null)
				{
					linkW.GetWorkingDirectory(path, path.Capacity);
				}
				else
				{
					linkA.GetWorkingDirectory(path, path.Capacity);
				}
				return path.ToString();
			}
			set
			{
				if (linkA == null)
				{
					linkW.SetWorkingDirectory(value);   
				}
				else
				{
					linkA.SetWorkingDirectory(value);
				}
			}
		}

		/// <summary>
		/// Gets/sets the description of the link
		/// </summary>
		public string Description
		{
			get
			{
				StringBuilder description = new StringBuilder(1024, 1024);
				if (linkA == null)
				{
					linkW.GetDescription(description, description.Capacity);
				}
				else
				{
					linkA.GetDescription(description, description.Capacity);
				}
				return description.ToString();
			}
			set
			{
				if (linkA == null)
				{
					linkW.SetDescription(value);
				}
				else
				{
					linkA.SetDescription(value);
				}
			}
		}

		/// <summary>
		/// Gets/sets any command line arguments associated with the link
		/// </summary>
		public string Arguments
		{
			get
			{            
				StringBuilder arguments = new StringBuilder(260, 260);
				if (linkA == null)
				{
					linkW.GetArguments(arguments, arguments.Capacity);
				}
				else
				{
					linkA.GetArguments(arguments, arguments.Capacity);
				}
				return arguments.ToString();
			}
			set
			{
				if (linkA == null)
				{
					linkW.SetArguments(value);
				}
				else
				{
					linkA.SetArguments(value);
				}
			}
		}

		/// <summary>
		/// Gets/sets the initial display mode when the shortcut is
		/// run
		/// </summary>
		public LinkDisplayMode DisplayMode
		{
			get
			{
				uint cmd = 0;
				if (linkA == null)
				{
					linkW.GetShowCmd(out cmd);
				}
				else
				{
					linkA.GetShowCmd(out cmd);
				}
				return (LinkDisplayMode)cmd;
			}
			set
			{
				if (linkA == null)
				{
					linkW.SetShowCmd((uint)value);
				}
				else
				{
					linkA.SetShowCmd((uint)value);
				}
			}
		}

		/// <summary>
		/// Gets/sets the HotKey to start the shortcut (if any)
		/// </summary>
		public Keys HotKey
		{
			get
			{
				short key = 0;
				if (linkA == null)
				{
					linkW.GetHotkey(out key);
				}
				else
				{
					linkA.GetHotkey(out key);
				}
				return (Keys)key;
			}
			set
			{
				if (linkA == null)
				{
					linkW.SetHotkey((short)value);
				}
				else
				{
					linkA.SetHotkey((short)value);
				}
			}
		}

		/// <summary>
		/// Saves the shortcut to ShortCutFile.
		/// </summary>
		public void Save()
		{
			Save(shortcutFile);
		}

		/// <summary>
		/// Saves the shortcut to the specified file
		/// </summary>
		/// <param name="linkFile">The shortcut file (.lnk)</param>
		public void Save(string linkFile)
		{   
			// Save the object to disk
			if (linkA == null)
			{
				((IPersistFile)linkW).Save(linkFile, true);
				shortcutFile = linkFile;
			}
			else
			{
				((IPersistFile)linkA).Save(linkFile, true);
				shortcutFile = linkFile;
			}
		}

		/// <summary>
		/// Loads a shortcut from the specified file
		/// </summary>
		/// <param name="linkFile">The shortcut file (.lnk) to load</param>
		public void Open(
			string linkFile         
			)
		{
			Open(linkFile, 
				IntPtr.Zero, 
				(EShellLinkResolveFlags.SLR_ANY_MATCH |
				EShellLinkResolveFlags.SLR_NO_UI),
				1);
		}
      
		/// <summary>
		/// Loads a shortcut from the specified file, and allows flags controlling
		/// the UI behaviour if the shortcut's target isn't found to be set.
		/// </summary>
		/// <param name="linkFile">The shortcut file (.lnk) to load</param>
		/// <param name="hWnd">The window handle of the application's UI, if		any</param>
		/// <param name="resolveFlags">Flags controlling resolution		behaviour</param>
		public void Open(
			string linkFile, 
			IntPtr hWnd, 
			EShellLinkResolveFlags resolveFlags
			)
		{
			Open(linkFile, 
				hWnd, 
				resolveFlags, 
				1);
		}

		/// <summary>
		/// Loads a shortcut from the specified file, and allows flags controlling
		/// the UI behaviour if the shortcut's target isn't found to be set.  If
		/// no SLR_NO_UI is specified, you can also specify a timeout.
		/// </summary>
		/// <param name="linkFile">The shortcut file (.lnk) to load</param>
		/// <param name="hWnd">The window handle of the application's UI, if		any</param>
		/// <param name="resolveFlags">Flags controlling resolution		behaviour</param>
		/// <param name="timeOut">Timeout if SLR_NO_UI is specified, in		ms.</param>
		public void Open(
			string linkFile,
			IntPtr hWnd, 
			EShellLinkResolveFlags resolveFlags,
			ushort timeOut
			)
		{
			uint flags;

			if ((resolveFlags & EShellLinkResolveFlags.SLR_NO_UI) 
				== EShellLinkResolveFlags.SLR_NO_UI)
			{
				flags = (uint)((int)resolveFlags | (timeOut << 16));
			}
			else
			{
				flags = (uint)resolveFlags;
			}

			if (linkA == null)
			{
				((IPersistFile)linkW).Load(linkFile, 0); //STGM_DIRECT)
				//linkW.Resolve(hWnd, flags);
				this.shortcutFile = linkFile;
			}
			else
			{
				((IPersistFile)linkA).Load(linkFile, 0); //STGM_DIRECT)
				//linkA.Resolve(hWnd, flags);
				this.shortcutFile = linkFile;
			}
		}
		#endregion
	}
	#endregion ShellLink
	
	#region SHFileOpts
	public class InteropSHFileOperation
	{
		public enum FO_Func : uint
		{
			FO_MOVE = 0x0001,
			FO_COPY = 0x0002,
			FO_DELETE = 0x0003,
			FO_RENAME = 0x0004,
		}

		//		struct SHFILEOPSTRUCT
		//		{
		//			public IntPtr hwnd;
		//			public FO_Func wFunc;
		//			[MarshalAs(UnmanagedType.LPWStr)]
		//			public string pFrom;
		//			[MarshalAs(UnmanagedType.LPWStr)]
		//			public string pTo;
		//			public ushort fFlags;
		//			public bool fAnyOperationsAborted;
		//			public IntPtr hNameMappings;
		//			[MarshalAs(UnmanagedType.LPWStr)]
		//			public string lpszProgressTitle;
		//
		//		}

		[StructLayout(LayoutKind.Sequential, CharSet=CharSet.Unicode)]
			public struct SHFILEOPSTRUCT
		{
			public IntPtr hwnd;						// Window handle to the dialog box to display information about the 
			// status of the file operation. 
			public FO_Func wFunc;					// Value that indicates which operation to perform.
			public IntPtr pFrom;					// Address of a buffer to specify one or more source file names. 
			// These names must be fully qualified paths. Standard Microsoft 
			// MS-DOS wild cards, such as "*", are permitted in the file-name 
			// position. Although this member is declared as a null-terminated 
			// string, it is used as a buffer to hold multiple file names. Each 
			// file name must be terminated by a single NULL character. An	
			// additional NULL character must be appended to the end of the 
			// final name to indicate the end of pFrom. 
			public IntPtr pTo;						// Address of a buffer to contain the name of the destination file or 
			// directory. This parameter must be set to NULL if it is not used.
			// Like pFrom, the pTo member is also a double-null terminated 
			// string and is handled in much the same way. 
			public UInt16 fFlags;					// Flags that control the file operation. 
			public Int32 fAnyOperationsAborted;		// Value that receives TRUE if the user aborted any file operations
			// before they were completed, or FALSE otherwise. 
			public IntPtr hNameMappings;			// A handle to a name mapping object containing the old and new 
			// names of the renamed files. This member is used only if the 
			// fFlags member includes the FOF_WANTMAPPINGHANDLE flag.
			[MarshalAs(UnmanagedType.LPWStr)]
			public String lpszProgressTitle;		// Address of a string to use as the title of a progress dialog box.
			// This member is used only if fFlags includes the 
			// FOF_SIMPLEPROGRESS flag.
		}

		/// <summary>
		/// SHs the file operation.
		/// </summary>
		/// <param name="lpFileOp">Lp file op.</param>
		/// <returns></returns>
		[DllImport("shell32.dll",  CharSet = CharSet.Unicode)]
		static extern int SHFileOperation(ref SHFILEOPSTRUCT lpFileOp);

		/// <summary>
		/// Creats the directory.
		/// </summary>
		/// <param name="folderPath">Folder path.</param>
		public void CreatDirectory(string folderPath)
		{
			System.IO.Directory.CreateDirectory(folderPath);
		}

		private SHFILEOPSTRUCT _ShFile;
		public FILEOP_FLAGS fFlags;

		public IntPtr hwnd
		{
			set
			{
				this._ShFile.hwnd = value;
			}
		}
		public FO_Func wFunc
		{
			set
			{
				this._ShFile.wFunc = value;
			}
		}

		public string pFrom
		{
			set
			{
				this._ShFile.pFrom = Marshal.StringToHGlobalUni(value + '\0');
			}
			get
			{
				return ""; //this._ShFile.pFrom;
			}
		}
		public string pTo
		{
			set
			{
				this._ShFile.pTo = Marshal.StringToHGlobalUni(value + '\0');
			}
			get
			{
				return ""; //this._ShFile.pTo;
			}
		}

		public bool fAnyOperationsAborted
		{
			get { return true; }
			//			set
			//			{
			//				this._ShFile.fAnyOperationsAborted = false;
			//			}
		}
		public IntPtr hNameMappings
		{
			set
			{
				this._ShFile.hNameMappings = value;
			}
		}
		public string lpszProgressTitle
		{
			set
			{
				this._ShFile.lpszProgressTitle = value + '\0';
			}
		}
		
		public InteropSHFileOperation()
		{
			
			this.fFlags = new FILEOP_FLAGS();
			this._ShFile = new SHFILEOPSTRUCT();
			this._ShFile.hwnd = IntPtr.Zero;
			this._ShFile.wFunc = FO_Func.FO_COPY;
			//			this._ShFile.pFrom = "";
			//			this._ShFile.pTo = "";
			this._ShFile.fAnyOperationsAborted = 0;
			this._ShFile.hNameMappings = IntPtr.Zero;
			this._ShFile.lpszProgressTitle = "";
			
		}
		
		public bool Execute()
		{
			this._ShFile.fFlags = this.fFlags.Flag;
			int ReturnValue = SHFileOperation(ref this._ShFile);
			if ( ReturnValue == 0 )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		
		public class FILEOP_FLAGS
		{
			private enum FILEOP_FLAGS_ENUM : ushort
			{
				FOF_MULTIDESTFILES = 0x0001,
				FOF_CONFIRMMOUSE = 0x0002,
				FOF_SILENT = 0x0004,  // don't create progress/report
				FOF_RENAMEONCOLLISION = 0x0008,
				FOF_NOCONFIRMATION = 0x0010,  // Don't prompt the user.
				FOF_WANTMAPPINGHANDLE = 0x0020,  // Fill in SHFILEOPSTRUCT.hNameMappings
				// Must be freed using SHFreeNameMappings
				FOF_ALLOWUNDO = 0x0040,
				FOF_FILESONLY = 0x0080,  // on *.*, do only files
				FOF_SIMPLEPROGRESS = 0x0100,  // means don't show names of files
				FOF_NOCONFIRMMKDIR = 0x0200,  // don't confirm making any needed dirs
				FOF_NOERRORUI = 0x0400,  // don't put up error UI
				FOF_NOCOPYSECURITYATTRIBS = 0x0800,  // dont copy NT file Security Attributes
				FOF_NORECURSION = 0x1000,  // don't recurse into directories.
				FOF_NO_CONNECTED_ELEMENTS = 0x2000,  // don't operate on connected elements.
				FOF_WANTNUKEWARNING = 0x4000,  // during delete operation, warn if nuking instead of recycling (partially overrides FOF_NOCONFIRMATION)
				FOF_NORECURSEREPARSE = 0x8000,  // treat reparse points as objects, not containers
			}
			
			public bool FOF_MULTIDESTFILES = false;
			public bool FOF_CONFIRMMOUSE = false;
			public bool FOF_SILENT = false;
			public bool FOF_RENAMEONCOLLISION = false;
			public bool FOF_NOCONFIRMATION = false;
			public bool FOF_WANTMAPPINGHANDLE = false;
			public bool FOF_ALLOWUNDO = false;
			public bool FOF_FILESONLY = false;
			public bool FOF_SIMPLEPROGRESS = false;
			public bool FOF_NOCONFIRMMKDIR = false;
			public bool FOF_NOERRORUI = false;
			public bool FOF_NOCOPYSECURITYATTRIBS = false;
			public bool FOF_NORECURSION = false;
			public bool FOF_NO_CONNECTED_ELEMENTS = false;
			public bool FOF_WANTNUKEWARNING = false;
			public bool FOF_NORECURSEREPARSE = false;
			public ushort Flag
			{
				get
				{
					ushort ReturnValue = 0;
					
					if ( this.FOF_MULTIDESTFILES == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_MULTIDESTFILES;
					if ( this.FOF_CONFIRMMOUSE == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_CONFIRMMOUSE;
					if ( this.FOF_SILENT == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_SILENT;
					if ( this.FOF_RENAMEONCOLLISION == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_RENAMEONCOLLISION;
					if ( this.FOF_NOCONFIRMATION == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_NOCONFIRMATION;
					if ( this.FOF_WANTMAPPINGHANDLE == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_WANTMAPPINGHANDLE;
					if ( this.FOF_ALLOWUNDO == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_ALLOWUNDO;
					if ( this.FOF_FILESONLY == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_FILESONLY;
					if ( this.FOF_SIMPLEPROGRESS == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_SIMPLEPROGRESS;
					if ( this.FOF_NOCONFIRMMKDIR == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_NOCONFIRMMKDIR;
					if ( this.FOF_NOERRORUI == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_NOERRORUI;
					if ( this.FOF_NOCOPYSECURITYATTRIBS == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_NOCOPYSECURITYATTRIBS;
					if ( this.FOF_NORECURSION == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_NORECURSION;
					if ( this.FOF_NO_CONNECTED_ELEMENTS == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_NO_CONNECTED_ELEMENTS;
					if ( this.FOF_WANTNUKEWARNING == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_WANTNUKEWARNING;
					if ( this.FOF_NORECURSEREPARSE == true )
						ReturnValue |= (ushort)FILEOP_FLAGS_ENUM.FOF_NORECURSEREPARSE;

					return ReturnValue;
				}
			}
		}

	}
	#endregion SHFileOpts
	
	#region FindFiles
	public class FindFiles
	{
		
		#region Win32 API
		[StructLayout(LayoutKind.Sequential, CharSet=CharSet.Auto)]
			public struct WIN32_FIND_DATA 
		{
			public FileAttributes dwFileAttributes;
			public FILETIME ftCreationTime;
			public FILETIME ftLastAccessTime;
			public FILETIME ftLastWriteTime;
			public uint nFileSizeHigh;
			public uint nFileSizeLow;
			public uint dwReserved0;
			public uint dwReserved1;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=260)]
			public string cFileName;
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=14)]
			public string cAlternateFileName;
		}

		[StructLayout(LayoutKind.Sequential)]
			public  struct SYSTEMTIME 
		{
			[MarshalAs(UnmanagedType.U2)] public short Year;
			[MarshalAs(UnmanagedType.U2)] public short Month;
			[MarshalAs(UnmanagedType.U2)] public short DayOfWeek;
			[MarshalAs(UnmanagedType.U2)] public short Day;
			[MarshalAs(UnmanagedType.U2)] public short Hour;
			[MarshalAs(UnmanagedType.U2)] public short Minute;
			[MarshalAs(UnmanagedType.U2)] public short Second;
			[MarshalAs(UnmanagedType.U2)] public short Milliseconds;
		}
		
		[DllImport("kernel32.dll")]
		public static extern bool FileTimeToLocalFileTime([In] ref FILETIME lpFileTime, out FILETIME lpLocalFileTime);
		
		[DllImport("kernel32.dll", CallingConvention=CallingConvention.Winapi,  SetLastError=true)]
		public static extern bool FileTimeToSystemTime([In] ref FILETIME lpFileTime, out SYSTEMTIME lpSystemTime);
		
		/// <summary>
		/// Finds the first file.
		/// </summary>
		/// <param name="lpFileName">Name of the lp file.</param>
		/// <param name="lpFindFileData">Lp find file data.</param>
		/// <returns></returns>
		[DllImport("kernel32.dll", CharSet=CharSet.Auto)]
		static extern IntPtr FindFirstFile(
			string lpFileName, 
			out WIN32_FIND_DATA
			lpFindFileData
			);
		/// <summary>
		/// Finds the next file.
		/// </summary>
		/// <param name="hFindFile">H find file.</param>
		/// <param name="lpFindFileData">Lp find file data.</param>
		/// <returns></returns>
		[DllImport("kernel32", CharSet=CharSet.Unicode)] 
		public static extern bool FindNextFile(
			IntPtr hFindFile, 
			out WIN32_FIND_DATA lpFindFileData
			);
		/// <summary>
		/// Finds the close.
		/// </summary>
		/// <param name="hFindFile">H find file.</param>
		/// <returns></returns>
		[DllImport("kernel32.dll")]
		static extern bool FindClose(
			IntPtr hFindFile
			);

		#endregion Win32 API
		
		#region Declares
		private TreeNode My_ParentNode = null;
		private Thread My_ActiveThread = null;
		private bool My_IsCanceled = false;
		#endregion Declares
		
		#region Functions
		public void cancel()
		{
			My_IsCanceled = true;
			My_ActiveThread.Abort();
		}
		public FindFiles(TreeNode parentForm)
		{
			My_ParentNode = parentForm;
		}
		
		public void expandNode()
		{
			My_ActiveThread = new Thread(new ThreadStart(ExpandNode));
			My_ActiveThread.Name = "expandNode";
			My_ActiveThread.Start();
		}
		public void expandPath()
		{
			My_ActiveThread = new Thread(new ThreadStart(ExpandPath));
			My_ActiveThread.Name = "expandPath"; //My_ParentNode.FullPath;
			My_ActiveThread.Start();
		}
		public void selectNode()
		{
			My_ActiveThread = new Thread(new ThreadStart(SelectNode));
			My_ActiveThread.Name = "selectNode"; //My_ParentNode.FullPath;
			My_ActiveThread.Start();
		}
		public void selectPath()
		{
			My_ActiveThread = new Thread(new ThreadStart(SelectPath));
			My_ActiveThread.Name = "SelectPath"; //My_ParentNode.FullPath;
			My_ActiveThread.Start();
		}

		
		public void expandNodeWait()
		{
			ExpandNode();
		}
		public void expandPathWait()
		{
			ExpandPath();
		}
		public void selectNodeWait()
		{
			SelectNode();
		}

		public void selectPathWait()
		{
			SelectPath();
		}

		
		private void ExpandNode()
		{
			IntPtr INVALID_HANDLE_VALUE = new IntPtr(-1);
			long size = 0;
			WIN32_FIND_DATA findData;
			ArrayList tmpFolders = new ArrayList();
			
			IntPtr findHandle;
			
			TreeNode tmpNodeW = My_ParentNode;
			string searchPath = "";
			
			searchPath = currentDirectoy(tmpNodeW);
			
			if (!Directory.Exists(searchPath))
			{
				My_ParentNode.TreeView.Parent.Invoke(new AddTreeViewNodeDelegate(((ExplorerCTRL)My_ParentNode.TreeView.Parent).AddTreeViewNode), new object[2]{tmpFolders, My_ParentNode}); 
				return;
			}
			
			findHandle = FindFirstFile(@"" + searchPath + "\\*", out findData);
			if (findHandle != INVALID_HANDLE_VALUE) 
			{
				
				do 
				{
					if ((findData.dwFileAttributes & FileAttributes.Directory) != 0) 
					{
						
						if (findData.cFileName != "." && findData.cFileName != "..") 
						{
							
							TreeNode [] tmpTreeChild = new TreeNode [1];
							tmpTreeChild[0] = new TreeNode("Searching...", 0, 0);
							TreeNode tmpNode = new TreeNode(findData.cFileName, 0, 0, tmpTreeChild);
							tmpNode.Tag = findData.cFileName;
							
							tmpFolders.Add(tmpNode);
							
						}
					}
					else 
					{
						
						size += (long)findData.nFileSizeLow + (long)findData.nFileSizeHigh * 4294967296;
					}
				} 
				while (FindNextFile(findHandle, out findData) && !My_IsCanceled);
				FindClose(findHandle);
				
			}
			
			if (!My_IsCanceled)
				My_ParentNode.TreeView.Parent.Invoke(new AddTreeViewNodeDelegate(((ExplorerCTRL)My_ParentNode.TreeView.Parent).AddTreeViewNode), new object[2]{tmpFolders, My_ParentNode}); 
			
			return;
			
		}
		
		private void ExpandPath()
		{
			IntPtr INVALID_HANDLE_VALUE = new IntPtr(-1);
			//long size = 0;
			WIN32_FIND_DATA findData;
			ArrayList tmpFolders = new ArrayList();

			IntPtr findHandle;

			TreeNode tmpNodeW = My_ParentNode;
			string searchPath = "";

			searchPath = currentDirectoy(tmpNodeW);
			
			if (!Directory.Exists(searchPath))
				return;
			
			findHandle = FindFirstFile(@"" + searchPath + "\\*", out findData);
			if (findHandle != INVALID_HANDLE_VALUE) 
			{
				
				do 
				{
					if ((findData.dwFileAttributes & FileAttributes.Directory) != 0) 
					{
						
						if (findData.cFileName != "." && findData.cFileName != "..") 
						{
							TreeNode [] tmpTreeChild = new TreeNode [1];
							tmpTreeChild[0] = new TreeNode("Searching...", 0, 0);
							TreeNode tmpNode = new TreeNode(findData.cFileName, 0, 0, tmpTreeChild);
							tmpNode.Tag = findData.cFileName;
							
							tmpFolders.Add(tmpNode);
							
						}
					}
				} 
				while (FindNextFile(findHandle, out findData) && !My_IsCanceled);
				FindClose(findHandle);
				
			}
			
			if (!My_IsCanceled)
				My_ParentNode.TreeView.Parent.Invoke(new AddTreeViewNodeDelegate(((ExplorerCTRL)My_ParentNode.TreeView.Parent).AddTreeViewNode), new object[2]{tmpFolders, My_ParentNode}); 

			return;

		}

		private void SelectNode()
		{
						
			try
			{
				IntPtr INVALID_HANDLE_VALUE = new IntPtr(-1);
				WIN32_FIND_DATA findData;
				
				ArrayList tmpFolders = new ArrayList();
				ArrayList tmpFiles = new ArrayList();
				ArrayList tmpFolders2 = new ArrayList();
				
				IntPtr findHandle;
				
				TreeNode tmpNodeW = My_ParentNode;
				string searchPath = "";
				
				searchPath = currentDirectoy(tmpNodeW);
				
				if (!Directory.Exists(searchPath))
				{
					My_ParentNode.TreeView.Parent.Invoke(new AddListViewDelegate(((ExplorerCTRL)My_ParentNode.TreeView.Parent).AddListView), new object[2]{tmpFolders, tmpFiles}); 
					return;
				}
				
				findHandle = FindFirstFile(@"" + searchPath + "\\*", out findData);
				if (findHandle != INVALID_HANDLE_VALUE) 
				{
				
					do 
					{
						if ((findData.dwFileAttributes & FileAttributes.Directory) != 0) 
						{
							if (findData.cFileName != "." && findData.cFileName != "..") 
							{
								
								tmpFolders.Add(findData); 
								
								TreeNode [] tmpTreeChild = new TreeNode [1];
								tmpTreeChild[0] = new TreeNode("Searching...", 0, 0);
								TreeNode tmpNode = new TreeNode(findData.cFileName, 0, 0, tmpTreeChild);
								tmpNode.Tag = findData.cFileName;
								
								tmpFolders2.Add(tmpNode);
								
							}
						}
						else 
						{
							tmpFiles.Add(findData); 
						}
					} 
					while (FindNextFile(findHandle, out findData) && !My_IsCanceled);
					FindClose(findHandle);
				
				}
				
				if (!My_IsCanceled)
					My_ParentNode.TreeView.Parent.Invoke(new AddListViewDelegate(((ExplorerCTRL)My_ParentNode.TreeView.Parent).AddListView), new object[2]{tmpFolders, tmpFiles}); 
				
			}
			catch (Exception WTF)
			{
				Trace.WriteLine("FindFiles -=SelectNode=- Error: " + WTF.Message + "\r\n" + WTF.StackTrace);
			}
			
			return;
			
		}
		private void SelectPath()
		{
			if (My_ParentNode.Parent == null)
				return;

			IntPtr INVALID_HANDLE_VALUE = new IntPtr(-1);
			WIN32_FIND_DATA findData;
			
			ArrayList tmpFolders = new ArrayList();
			ArrayList tmpFiles = new ArrayList();

			IntPtr findHandle;
			
			TreeNode tmpNodeW = My_ParentNode;
			string searchPath = "";
			
			searchPath = currentDirectoy(tmpNodeW);
			
			if (!Directory.Exists(searchPath))
				return;
			
			findHandle = FindFirstFile(@"" + searchPath + "\\*", out findData);
			if (findHandle != INVALID_HANDLE_VALUE) 
			{
				
				do 
				{
					if ((findData.dwFileAttributes & FileAttributes.Directory) != 0) 
					{
						if (findData.cFileName != "." && findData.cFileName != "..") 
							tmpFolders.Add(findData.cFileName); 
					}
					else 
					{
						tmpFiles.Add(findData.cFileName); 
					}
				} 
				while (FindNextFile(findHandle, out findData) && !My_IsCanceled);
				FindClose(findHandle);
				
			}

			if (!My_IsCanceled)
				My_ParentNode.TreeView.Parent.Invoke(new AddListViewDelegate(((ExplorerCTRL)My_ParentNode.TreeView.Parent).AddListViewRL), new object[2]{tmpFolders, tmpFiles}); 

			return;
			
		}

		public string currentDirectoy(TreeNode currentNode)
		{
			
			string directory = "";
				
			TreeNode tmpNodeW = currentNode;

			if (tmpNodeW.Parent == null && tmpNodeW.Tag != null)
			{
				directory = tmpNodeW.Tag.ToString();
			}
			else
			{
				while (tmpNodeW.Parent != null)
				{
					directory = (tmpNodeW.Tag != null && tmpNodeW.Tag.ToString() != "" ? tmpNodeW.Tag + "\\" + directory : directory);
					tmpNodeW = tmpNodeW.Parent;
				}
			}
			
			return directory;
			
		}
		#endregion Functions
		
	}
	#endregion FindFiles
	
	#region extractIcon
	public class wdExtractIcon
	{ 
		
		#region Win32 API

		[DllImport("shell32.dll")]
		[return : MarshalAs(UnmanagedType.Bool)]
		public static extern bool SHGetPathFromIDListW(IntPtr pidl, [MarshalAs(UnmanagedType.LPTStr)] StringBuilder pszPath);
		
		public enum CSIDL 
		{
			ADMINTOOLS        = 0x0030,
			ALTSTARTUP        = 0x001d,
			APPDATA           = 0x001a,
			BITBUCKET         = 0x000a,
			CDBURN_AREA           = 0x003b,
			COMMON_ADMINTOOLS     = 0x002f,
			COMMON_ALTSTARTUP     = 0x001e,
			COMMON_APPDATA        = 0x0023,
			COMMON_DESKTOPDIRECTORY   = 0x0019,
			COMMON_DOCUMENTS      = 0x002e,
			COMMON_FAVORITES      = 0x001f,
			COMMON_MUSIC          = 0x0035,
			COMMON_OEM_LINKS      = 0x003a,
			COMMON_PICTURES       = 0x0036,
			COMMON_PROGRAMS       = 0X0017,
			COMMON_STARTMENU      = 0x0016,
			COMMON_STARTUP        = 0x0018,
			COMMON_TEMPLATES      = 0x002d,
			COMMON_VIDEO          = 0x0037,
			COMPUTERSNEARME       = 0x003d,
			CONNECTIONS           = 0x0031,
			CONTROLS          = 0x0003,
			COOKIES           = 0x0021,
			DESKTOP           = 0x0000,
			DESKTOPDIRECTORY      = 0x0010,
			MYCOMPUTER            = 0x0011,
			FAVORITES         = 0x0006,
			FLAG_CREATE           = 0x8000,
			FLAG_DONT_VERIFY      = 0x4000,
			FLAG_MASK         = 0xFF00,
			FLAG_NO_ALIAS         = 0x1000,
			FLAG_PER_USER_INIT    = 0x0800,
			FONTS             = 0x0014,
			HISTORY           = 0x0022,
			INTERNET          = 0x0001,
			INTERNET_CACHE        = 0x0020,
			LOCAL_APPDATA         = 0x001c,
			MYDOCUMENTS           = 0x000c,
			MYMUSIC           = 0x000d,
			MYPICTURES        = 0x0027,
			MYVIDEO           = 0x000e,
			NETHOOD           = 0x0013,
			NETWORK           = 0x0012,
			PERSONAL          = 0x0005,
			PRINTERS          = 0x0004,
			PRINTHOOD         = 0x001b,
			PROFILE           = 0x0028,
			PROGRAM_FILES         = 0x0026,
			PROGRAM_FILES_COMMON      = 0x002b,
			PROGRAM_FILES_COMMONX86   = 0x002c,
			PROGRAM_FILESX86      = 0x002a,
			PROGRAMS          = 0x0002,
			RECENT            = 0x0008,
			RESOURCES         = 0x0038,
			RESOURCES_LOCALIZED       = 0x0039,
			SENDTO            = 0x0009,
			STARTMENU         = 0x000b,
			STARTUP           = 0x0007,
			SYSTEM            = 0x0025,
			SYSTEMX86         = 0x0029,
			TEMPLATES         = 0x0015,
			WINDOWS           = 0x0024   
		}
		[DllImport("shell32.dll", SetLastError = true)]
		static extern int SHGetSpecialFolderLocation(IntPtr hwndOwner, 
			CSIDL nFolder,
			ref IntPtr ppidl);
		

		[DllImport("shell32.dll", CharSet=CharSet.Auto)] 
		static extern IntPtr SHGetFileInfo(string pszPath, int dwFileAttributes, 
			out SHFILEINFO psfi, int cbFileInfo, int uFlags); 

		/// <summary>
		/// SHs the get file info.
		/// </summary>
		/// <param name="pszPath">PSZ path.</param>
		/// <param name="dwFileAttributes">Dw file attributes.</param>
		/// <param name="psfi">Psfi.</param>
		/// <param name="cbfileInfo">Cbfile info.</param>
		/// <param name="uFlags">U flags.</param>
		/// <returns></returns>
		[DllImport("Shell32.dll")] 
		private static extern int  SHGetFileInfo 
			( 
			IntPtr pszPath, 
			uint dwFileAttributes, 
			out SHFILEINFO psfi, 
			uint cbfileInfo, 
			SHGFI uFlags 
			); 

		[DllImport("shell32.dll", CharSet = CharSet.Auto, CallingConvention = 
			 CallingConvention.Winapi)] 
		public static extern IntPtr ExtractIcon(IntPtr hInstance, string 
			strFileName, uint uiIconIndex); 

		[DllImport("shell32.dll", CharSet = CharSet.Auto, CallingConvention = 
			 CallingConvention.Winapi)] 
		private static extern int PickIconDlg(IntPtr hwndOwner, 
			System.Text.StringBuilder lpstrFile, int nMaxFile, ref int lpdwIconIndex); 


		/// <summary>
		/// Draws the icon or cursor using the mask.
		/// </summary>
		public const int DI_MASK = 0x0001;

		/// <summary>
		/// Draws the icon or cursor using the image.
		/// </summary>
		public const int DI_IMAGE = 0x0002;

		/// <summary>
		/// Combination of DI_IMAGE and DI_MASK.
		/// </summary>
		public const int DI_NORMAL = 0x0003;

		/// <summary>
		/// Draws the icon or cursor using the system default image rather than the user-specified image. 
		/// For more information, see About Cursors. Windows NT4.0 and later: This flag is ignored.
		/// </summary>
		public const int DI_COMPAT = 0x0004;

		/// <summary>
		/// Draws the icon or cursor using the width and height specified by the system metric values for cursors or icons, 
		/// if the cxWidth and cyWidth parameters are set to zero. If this flag is not specified and cxWidth and cyWidth are set to zero, 
		/// the function uses the actual resource size. 
		/// </summary>
		public const int DI_DEFAULTSIZE = 0x0008;

		/// <summary>
		/// Windows XP: Draws the icon as an unmirrored icon. By default, the icon is drawn as a mirrored icon if hdc is mirrored.
		/// </summary>
		public const int DI_NOMIRROR = 0x0010;
		
		[DllImport("user32.dll", SetLastError = true)]
		static extern bool DrawIconEx(IntPtr hdc, int xLeft, int yTop, IntPtr hIcon,
			int cxWidth, int cyHeight, int istepIfAniCur, IntPtr hbrFlickerFreeDraw,
			int diFlags);

		[StructLayout(LayoutKind.Sequential,CharSet=CharSet.Auto)] 
			struct SHFILEINFO 
		{ 
			private const int MAX_PATH = 260; 
			public IntPtr hIcon; 
			public int iIcon; 
			public int dwAttributes; 
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=MAX_PATH)] 
			public string szDisplayName; 
			[MarshalAs(UnmanagedType.ByValTStr, SizeConst=80)] 
			public string szTypeName; 


		}


		/// <summary>
		/// Creates a new <see cref="ExtractIcon"/> instance.
		/// </summary>
		private wdExtractIcon() 
		{ 
		} 

		private enum SHGFI 
		{ 
			SmallIcon   = 0x00000001, 
			LargeIcon   = 0x00000000, 
			Icon    = 0x00000100, 
			DisplayName   = 0x00000200, 
			Typename   = 0x00000400, 
			SysIconIndex  = 0x00004000, 
			UseFileAttributes = 0x00000010,
			Selected = 0x00010000,
			Linkoverlay = 0x00008000,
			ShellIconSize = 0x00000004,
			Exetype = 0x00002000,
			FILE_ATTRIBUTRE_NORMAL = 0x4000,
			PIDL = 0x00000008
		} 
		#endregion Win32 API
		
		#region Functions
		/// <summary>
		/// Gets the icon.
		/// </summary>
		/// <param name="strPath">STR path.</param>
		/// <param name="bSmall">B small.</param>
		/// <returns></returns>
		public static Icon GetIcon(CSIDL iconIndex, out string FileType, out string DisplayName) 
		{ 
			
			SHFILEINFO info = new SHFILEINFO(); 
			int cbFileInfo = Marshal.SizeOf(info); 
			SHGFI flags;
			
			IntPtr ppidl = IntPtr.Zero;
			SHGetSpecialFolderLocation(IntPtr.Zero, iconIndex, ref ppidl);
			Icon tmpIco = null;
			
			flags = SHGFI.PIDL|SHGFI.SysIconIndex|SHGFI.Icon|SHGFI.Typename|SHGFI.DisplayName|SHGFI.UseFileAttributes; 
			SHGetFileInfo(ppidl, 0, out info, (uint)cbFileInfo, flags); 
			tmpIco = Icon.FromHandle(info.hIcon);
			
			FileType = info.szTypeName;
			DisplayName = info.szDisplayName;
			return tmpIco;
			
		} 
		public static Icon GetIcon(string strPath, out string FileType, out string DisplayName, bool LargeIcon)
		{
			
			SHFILEINFO info = new SHFILEINFO(); 
			int cbFileInfo = Marshal.SizeOf(info); 
			SHGFI flags;
			
			Icon tmpIco = null;
			
			if (Directory.Exists(strPath))
			{
				flags = SHGFI.Icon|SHGFI.SysIconIndex| (LargeIcon ? SHGFI.LargeIcon : SHGFI.SmallIcon) | SHGFI.Typename|SHGFI.DisplayName; 
				SHGetFileInfo(strPath, (int)SHGFI.FILE_ATTRIBUTRE_NORMAL, out info, cbFileInfo, (int)flags); 
				tmpIco = Icon.FromHandle(info.hIcon);
			}
			else
			{
				if (Path.GetExtension(strPath).ToUpper() == ".LNK")
				{
					info.szTypeName = "Shortcut";
					info.szDisplayName = "";
					try
					{
						ShellLink tmpSL = new ShellLink(strPath);
						if (LargeIcon)
							tmpIco = tmpSL.LargeIcon;
						else
							tmpIco = tmpSL.SmallIcon;
					}
					catch{}
				}
				else if (File.Exists(strPath))
				{
					flags = SHGFI.Icon|SHGFI.UseFileAttributes|(LargeIcon ? SHGFI.LargeIcon : SHGFI.SmallIcon); 
					try
					{
						SHGetFileInfo(strPath, 0, out info, cbFileInfo, (int)flags); 
					}
					catch{}
					try
					{
						tmpIco = Icon.FromHandle(info.hIcon);
					}
					catch
					{
						tmpIco = null;
					}
				}
				else
				{
					flags = SHGFI.Icon|SHGFI.UseFileAttributes|(LargeIcon ? SHGFI.LargeIcon : SHGFI.SmallIcon)|SHGFI.Typename|SHGFI.DisplayName; 
					try
					{
						SHGetFileInfo(strPath, 0, out info, cbFileInfo, (int)flags); 
					}
					catch{}
					try
					{
						tmpIco = Icon.FromHandle(info.hIcon);
					}
					catch
					{
						tmpIco = null;
					}
				}
			}
			
			FileType = "";
			DisplayName = "";
			
			try
			{
				FileType = (info.szTypeName == "" ? strPath.Substring(strPath.Length-4,4) + " File" : info.szTypeName);
			}
			catch{}
			
			try
			{
				DisplayName = (info.szDisplayName == "" ? strPath.Substring(strPath.Length-4,4) + " File" : info.szDisplayName);
			}
			catch{}
			
			return tmpIco;
			
		}
		public static Icon GetIconShortcut(string strPath, bool LargeIcon)
		{
			
			SHFILEINFO info = new SHFILEINFO(); 
			int cbFileInfo = Marshal.SizeOf(info); 
			SHGFI flags;
			
			Icon tmpIco = null;
			flags = SHGFI.Icon|SHGFI.UseFileAttributes|(LargeIcon ? SHGFI.LargeIcon : SHGFI.SmallIcon)|SHGFI.Linkoverlay; 
			SHGetFileInfo(strPath, 0, out info, cbFileInfo, (int)flags); 
			tmpIco = Icon.FromHandle(info.hIcon);
			
			return tmpIco;
			
		}
		public static Icon extractIcon(string strPath, int nIndex) 
		{ 
			Icon icon = null; 
			IntPtr hIcon = ExtractIcon(IntPtr.Zero, strPath, (uint)nIndex); 
			if (IntPtr.Zero != hIcon) 
			{ 
				icon = Icon.FromHandle(hIcon); 
			} 
			return icon; 


		} 
				
		#endregion Functions
		
	}
	#endregion extractIcon
	
	#endregion Helper Classes
	
	#region Delegates
		
	#region TreeNode Delegates
	public delegate void exBeginNodeCollapes(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
	public delegate void exEndNodeCollapes(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
	public delegate void exBeginNodeExpand(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
	public delegate void exEndNodeExpand(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
	public delegate void exBeginNewTreeNode(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
	public delegate void exEndNewTreeNode(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
	public delegate void exBeginNodeSelect(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
	public delegate void exEndNodeSelect(object sender, ref System.Windows.Forms.TreeViewCancelEventArgs e);
		
	public delegate void exBeginBuildTree(object sender, ref TreeNode[] userNodes);
	public delegate void exEndBuildTree(object sender, ref TreeNode[] userNodes);
	#endregion TreeNode Delegates
		
	#region File/Folder Delegates
	public delegate void exBeginRenameFile(object sender, ref System.Windows.Forms.LabelEditEventArgs e);
	public delegate void exEndRenameFile(object sender, ref System.Windows.Forms.LabelEditEventArgs e);
	
	public delegate void exBeginRenameFolder(object sender, ref System.Windows.Forms.LabelEditEventArgs e);
	public delegate void exEndRenameFolder(object sender, ref System.Windows.Forms.LabelEditEventArgs e);
	
	public delegate void exBeginExecuteFile(string fileName, ref bool allowIt);
	public delegate void exEndExecuteFile(string fileName, IntPtr parentHandel);
	
	public delegate void exDeleteFile(string fileName, ref bool allow);
	
	public delegate void exDirectoryChanged(string directoryPath, Image selectedIcon);
	#endregion File/Folder Delegates
	
	public delegate void exStatusBar(string pan1, string pan2, string pan3);
	public delegate void exShowProgress();
	public delegate void exStopProgress();
	
	#region Internal Delegates
	public delegate int exCompareNodes(IntPtr lParam1, IntPtr lParam2, IntPtr lParamSort); 
	internal delegate void exAddImageIcon(Image fileIcon, ImageList imageTo);
	internal delegate void exBrowse(string directoryPath);
	internal delegate void exSetItemImageIndex(ListViewItem iToChange);
	internal delegate void AddSingleTreeNodeDelegate(TreeNode newNodes, TreeNode prevNode);
	internal delegate void AddTreeViewNodeDelegate(ArrayList newNodes, TreeNode prevNode);
	internal delegate void AddListViewDelegate(ArrayList newFolders, ArrayList newFiles);
	internal delegate void AddListViewDelegateRL(ArrayList newFolders, ArrayList newFiles);
	#endregion Internal Delegates
		
	#endregion Delegates
	
}